<?php

/*
Plugin Name: All in One SEO Pack
Plugin URI: http://wpworld.ru/all-in-one-seo-pack-na-russkom/
Description: All-In-One-SEO-Pack - один из лучших плагинов для оптимизации Wordpress. Скачано с <a href="http://wpworld.ru" terget="_blank" title="Мир Wordpress">Мир wordpress</a>, переведено на сайте <a href="http://wpthemes.ru" title="Темы для wordpress" target="_blank">Темы для wordpress</a>.
Version: 1.4.6.13
Author: Michael Torbert
Author URI: http://semperfiwebdesign.com
*/

/*
Copyright (C) 2008 Michael Torbert, semperfiwebdesign.com (michael AT semperfiwebdesign DOT com)
Original code by uberdose of uberdose.com

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/*******************************************************************************************************/

$UTF8_TABLES['strtolower'] = array(
	"пјє" => "пЅљ",	"пј№" => "пЅ™",	"пјё" => "пЅ",
	"пј·" => "пЅ—",	"пј¶" => "пЅ–",	"пјµ" => "пЅ•",
	"пјґ" => "пЅ”",	"пјі" => "пЅ“",	"пјІ" => "пЅ’",
	"пј±" => "пЅ‘",	"пј°" => "пЅђ",	"пјЇ" => "пЅЏ",
	"пј®" => "пЅЋ",	"пј­" => "пЅЌ",	"пј¬" => "пЅЊ",
	"пј«" => "пЅ‹",	"пјЄ" => "пЅЉ",	"пј©" => "пЅ‰",
	"пјЁ" => "пЅ€",	"пј§" => "пЅ‡",	"пј¦" => "пЅ†",
	"пјҐ" => "пЅ…",	"пј¤" => "пЅ„",	"пјЈ" => "пЅѓ",
	"пјў" => "пЅ‚",	"пјЎ" => "пЅЃ",	"в„«" => "ГҐ",
	"в„Є" => "k",	"в„¦" => "П‰",	"бї»" => "бЅЅ",
	"бїє" => "бЅј",	"бї№" => "бЅ№",	"бїё" => "бЅё",
	"бї¬" => "бїҐ",	"бї«" => "бЅ»",	"бїЄ" => "бЅє",
	"бї©" => "бїЎ",	"бїЁ" => "бї ",	"бї›" => "бЅ·",
	"бїљ" => "бЅ¶",	"бї™" => "бї‘",	"бї" => "бїђ",
	"бї‹" => "бЅµ",	"бїЉ" => "бЅґ",	"бї‰" => "бЅі",
	"бї€" => "бЅІ",	"бѕ»" => "бЅ±",	"бѕє" => "бЅ°",
	"бѕ№" => "бѕ±",	"бѕё" => "бѕ°",	"бЅЇ" => "бЅ§",
	"бЅ®" => "бЅ¦",	"бЅ­" => "бЅҐ",	"бЅ¬" => "бЅ¤",
	"бЅ«" => "бЅЈ",	"бЅЄ" => "бЅў",	"бЅ©" => "бЅЎ",
	"бЅЁ" => "бЅ ",	"бЅџ" => "бЅ—",	"бЅќ" => "бЅ•",
	"бЅ›" => "бЅ“",	"бЅ™" => "бЅ‘",	"бЅЌ" => "бЅ…",
	"бЅЊ" => "бЅ„",	"бЅ‹" => "бЅѓ",	"бЅЉ" => "бЅ‚",
	"бЅ‰" => "бЅЃ",	"бЅ€" => "бЅЂ",	"бјї" => "бј·",
	"бјѕ" => "бј¶",	"бјЅ" => "бјµ",	"бјј" => "бјґ",
	"бј»" => "бјі",	"бјє" => "бјІ",	"бј№" => "бј±",
	"бјё" => "бј°",	"бјЇ" => "бј§",	"бј®" => "бј¦",
	"бј­" => "бјҐ",	"бј¬" => "бј¤",	"бј«" => "бјЈ",
	"бјЄ" => "бјў",	"бј©" => "бјЎ",	"бјЁ" => "бј ",
	"бјќ" => "бј•",	"бјњ" => "бј”",	"бј›" => "бј“",
	"бјљ" => "бј’",	"бј™" => "бј‘",	"бј" => "бјђ",
	"бјЏ" => "бј‡",	"бјЋ" => "бј†",	"бјЌ" => "бј…",
	"бјЊ" => "бј„",	"бј‹" => "бјѓ",	"бјЉ" => "бј‚",
	"бј‰" => "бјЃ",	"бј€" => "бјЂ",	"б»ё" => "б»№",
	"б»¶" => "б»·",	"б»ґ" => "б»µ",	"б»І" => "б»і",
	"б»°" => "б»±",	"б»®" => "б»Ї",	"б»¬" => "б»­",
	"б»Є" => "б»«",	"б»Ё" => "б»©",	"б»¦" => "б»§",
	"б»¤" => "б»Ґ",	"б»ў" => "б»Ј",	"б» " => "б»Ў",
	"б»ћ" => "б»џ",	"б»њ" => "б»ќ",	"б»љ" => "б»›",
	"б»" => "б»™",	"б»–" => "б»—",	"б»”" => "б»•",
	"б»’" => "б»“",	"б»ђ" => "б»‘",	"б»Ћ" => "б»Џ",
	"б»Њ" => "б»Ќ",	"б»Љ" => "б»‹",	"б»€" => "б»‰",
	"б»†" => "б»‡",	"б»„" => "б»…",	"б»‚" => "б»ѓ",
	"б»Ђ" => "б»Ѓ",	"бєѕ" => "бєї",	"бєј" => "бєЅ",
	"бєє" => "бє»",	"бєё" => "бє№",	"бє¶" => "бє·",
	"бєґ" => "бєµ",	"бєІ" => "бєі",	"бє°" => "бє±",
	"бє®" => "бєЇ",	"бє¬" => "бє­",	"бєЄ" => "бє«",
	"бєЁ" => "бє©",	"бє¦" => "бє§",	"бє¤" => "бєҐ",
	"бєў" => "бєЈ",	"бє " => "бєЎ",	"бє”" => "бє•",
	"бє’" => "бє“",	"бєђ" => "бє‘",	"бєЋ" => "бєЏ",
	"бєЊ" => "бєЌ",	"бєЉ" => "бє‹",	"бє€" => "бє‰",
	"бє†" => "бє‡",	"бє„" => "бє…",	"бє‚" => "бєѓ",
	"бєЂ" => "бєЃ",	"б№ѕ" => "б№ї",	"б№ј" => "б№Ѕ",
	"б№є" => "б№»",	"б№ё" => "б№№",	"б№¶" => "б№·",
	"б№ґ" => "б№µ",	"б№І" => "б№і",	"б№°" => "б№±",
	"б№®" => "б№Ї",	"б№¬" => "б№­",	"б№Є" => "б№«",
	"б№Ё" => "б№©",	"б№¦" => "б№§",	"б№¤" => "б№Ґ",
	"б№ў" => "б№Ј",	"б№ " => "б№Ў",	"б№ћ" => "б№џ",
	"б№њ" => "б№ќ",	"б№љ" => "б№›",	"б№" => "б№™",
	"б№–" => "б№—",	"б№”" => "б№•",	"б№’" => "б№“",
	"б№ђ" => "б№‘",	"б№Ћ" => "б№Џ",	"б№Њ" => "б№Ќ",
	"б№Љ" => "б№‹",	"б№€" => "б№‰",	"б№†" => "б№‡",
	"б№„" => "б№…",	"б№‚" => "б№ѓ",	"б№Ђ" => "б№Ѓ",
	"бёѕ" => "бёї",	"бёј" => "бёЅ",	"бёє" => "бё»",
	"бёё" => "бё№",	"бё¶" => "бё·",	"бёґ" => "бёµ",
	"бёІ" => "бёі",	"бё°" => "бё±",	"бё®" => "бёЇ",
	"бё¬" => "бё­",	"бёЄ" => "бё«",	"бёЁ" => "бё©",
	"бё¦" => "бё§",	"бё¤" => "бёҐ",	"бёў" => "бёЈ",
	"бё " => "бёЎ",	"бёћ" => "бёџ",	"бёњ" => "бёќ",
	"бёљ" => "бё›",	"бё" => "бё™",	"бё–" => "бё—",
	"бё”" => "бё•",	"бё’" => "бё“",	"бёђ" => "бё‘",
	"бёЋ" => "бёЏ",	"бёЊ" => "бёЌ",	"бёЉ" => "бё‹",
	"бё€" => "бё‰",	"бё†" => "бё‡",	"бё„" => "бё…",
	"бё‚" => "бёѓ",	"бёЂ" => "бёЃ",	"Х–" => "Ц†",
	"Х•" => "Ц…",	"Х”" => "Ц„",	"Х“" => "Цѓ",
	"Х’" => "Ц‚",	"Х‘" => "ЦЃ",	"Хђ" => "ЦЂ",
	"ХЏ" => "Хї",	"ХЋ" => "Хѕ",	"ХЌ" => "ХЅ",
	"ХЊ" => "Хј",	"Х‹" => "Х»",	"ХЉ" => "Хє",
	"Х‰" => "Х№",	"Х€" => "Хё",	"Х‡" => "Х·",
	"Х†" => "Х¶",	"Х…" => "Хµ",	"Х„" => "Хґ",
	"Хѓ" => "Хі",	"Х‚" => "ХІ",	"ХЃ" => "Х±",
	"ХЂ" => "Х°",	"Фї" => "ХЇ",	"Фѕ" => "Х®",
	"ФЅ" => "Х­",	"Фј" => "Х¬",	"Ф»" => "Х«",
	"Фє" => "ХЄ",	"Ф№" => "Х©",	"Фё" => "ХЁ",
	"Ф·" => "Х§",	"Ф¶" => "Х¦",	"Фµ" => "ХҐ",
	"Фґ" => "Х¤",	"Фі" => "ХЈ",	"ФІ" => "Хў",
	"Ф±" => "ХЎ",	"ФЋ" => "ФЏ",	"ФЊ" => "ФЌ",
	"ФЉ" => "Ф‹",	"Ф€" => "Ф‰",	"Ф†" => "Ф‡",
	"Ф„" => "Ф…",	"Ф‚" => "Фѓ",	"ФЂ" => "ФЃ",
	"Уё" => "У№",	"Уґ" => "Уµ",	"УІ" => "Уі",
	"У°" => "У±",	"У®" => "УЇ",	"У¬" => "У­",
	"УЄ" => "У«",	"УЁ" => "У©",	"У¦" => "У§",
	"У¤" => "УҐ",	"Уў" => "УЈ",	"У " => "УЎ",
	"Ућ" => "Уџ",	"Уњ" => "Уќ",	"Уљ" => "У›",
	"У" => "У™",	"У–" => "У—",	"У”" => "У•",
	"У’" => "У“",	"Уђ" => "У‘",	"УЌ" => "УЋ",
	"У‹" => "УЊ",	"У‰" => "УЉ",	"У‡" => "У€",
	"У…" => "У†",	"Уѓ" => "У„",	"УЃ" => "У‚",
	"Тѕ" => "Тї",	"Тј" => "ТЅ",	"Тє" => "Т»",
	"Тё" => "Т№",	"Т¶" => "Т·",	"Тґ" => "Тµ",
	"ТІ" => "Ті",	"Т°" => "Т±",	"Т®" => "ТЇ",
	"Т¬" => "Т­",	"ТЄ" => "Т«",	"ТЁ" => "Т©",
	"Т¦" => "Т§",	"Т¤" => "ТҐ",	"Тў" => "ТЈ",
	"Т " => "ТЎ",	"Тћ" => "Тџ",	"Тњ" => "Тќ",
	"Тљ" => "Т›",	"Т" => "Т™",	"Т–" => "Т—",
	"Т”" => "Т•",	"Т’" => "Т“",	"Тђ" => "Т‘",
	"ТЋ" => "ТЏ",	"ТЊ" => "ТЌ",	"ТЉ" => "Т‹",
	"ТЂ" => "ТЃ",	"Сѕ" => "Сї",	"Сј" => "СЅ",
	"Сє" => "С»",	"Сё" => "С№",	"С¶" => "С·",
	"Сґ" => "Сµ",	"СІ" => "Сі",	"С°" => "С±",
	"С®" => "СЇ",	"С¬" => "С­",	"СЄ" => "С«",
	"СЁ" => "С©",	"С¦" => "С§",	"С¤" => "СҐ",
	"Сў" => "СЈ",	"С " => "СЎ",	"РЇ" => "СЏ",
	"Р®" => "СЋ",	"Р­" => "СЌ",	"Р¬" => "СЊ",
	"Р«" => "С‹",	"РЄ" => "СЉ",	"Р©" => "С‰",
	"РЁ" => "С€",	"Р§" => "С‡",	"Р¦" => "С†",
	"РҐ" => "С…",	"Р¤" => "С„",	"РЈ" => "Сѓ",
	"Рў" => "С‚",	"РЎ" => "СЃ",	"Р " => "СЂ",
	"Рџ" => "Рї",	"Рћ" => "Рѕ",	"Рќ" => "РЅ",
	"Рњ" => "Рј",	"Р›" => "Р»",	"Рљ" => "Рє",
	"Р™" => "Р№",	"Р" => "Рё",	"Р—" => "Р·",
	"Р–" => "Р¶",	"Р•" => "Рµ",	"Р”" => "Рґ",
	"Р“" => "Рі",	"Р’" => "РІ",	"Р‘" => "Р±",
	"Рђ" => "Р°",	"РЏ" => "Сџ",	"РЋ" => "Сћ",
	"РЌ" => "Сќ",	"РЊ" => "Сњ",	"Р‹" => "С›",
	"РЉ" => "Сљ",	"Р‰" => "С™",	"Р€" => "С",
	"Р‡" => "С—",	"Р†" => "С–",	"Р…" => "С•",
	"Р„" => "С”",	"Рѓ" => "С“",	"Р‚" => "С’",
	"РЃ" => "С‘",	"РЂ" => "Сђ",	"Пґ" => "Оё",
	"П®" => "ПЇ",	"П¬" => "П­",	"ПЄ" => "П«",
	"ПЁ" => "П©",	"П¦" => "П§",	"П¤" => "ПҐ",
	"Пў" => "ПЈ",	"П " => "ПЎ",	"Пћ" => "Пџ",
	"Пњ" => "Пќ",	"Пљ" => "П›",	"П" => "П™",
	"О«" => "П‹",	"ОЄ" => "ПЉ",	"О©" => "П‰",
	"ОЁ" => "П€",	"О§" => "П‡",	"О¦" => "П†",
	"ОҐ" => "П…",	"О¤" => "П„",	"ОЈ" => "Пѓ",
	"ОЎ" => "ПЃ",	"О " => "ПЂ",	"Оџ" => "Ої",
	"Оћ" => "Оѕ",	"Оќ" => "ОЅ",	"Оњ" => "Ој",
	"О›" => "О»",	"Ољ" => "Оє",	"О™" => "О№",
	"О" => "Оё",	"О—" => "О·",	"О–" => "О¶",
	"О•" => "Оµ",	"О”" => "Оґ",	"О“" => "Оі",
	"О’" => "ОІ",	"О‘" => "О±",	"ОЏ" => "ПЋ",
	"ОЋ" => "ПЌ",	"ОЊ" => "ПЊ",	"ОЉ" => "ОЇ",
	"О‰" => "О®",	"О€" => "О­",	"О†" => "О¬",
	"ИІ" => "Иі",	"И°" => "И±",	"И®" => "ИЇ",
	"И¬" => "И­",	"ИЄ" => "И«",	"ИЁ" => "И©",
	"И¦" => "И§",	"И¤" => "ИҐ",	"Иў" => "ИЈ",
	"И " => "Жћ",	"Ић" => "Иџ",	"Ињ" => "Иќ",
	"Иљ" => "И›",	"И" => "И™",	"И–" => "И—",
	"И”" => "И•",	"И’" => "И“",	"Иђ" => "И‘",
	"ИЋ" => "ИЏ",	"ИЊ" => "ИЌ",	"ИЉ" => "И‹",
	"И€" => "И‰",	"И†" => "И‡",	"И„" => "И…",
	"И‚" => "Иѓ",	"ИЂ" => "ИЃ",	"Зѕ" => "Зї",
	"Зј" => "ЗЅ",	"Зє" => "З»",	"Зё" => "З№",
	"З·" => "Жї",	"З¶" => "Ж•",	"Зґ" => "Зµ",
	"З±" => "Зі",	"З®" => "ЗЇ",	"З¬" => "З­",
	"ЗЄ" => "З«",	"ЗЁ" => "З©",	"З¦" => "З§",
	"З¤" => "ЗҐ",	"Зў" => "ЗЈ",	"З " => "ЗЎ",
	"Зћ" => "Зџ",	"З›" => "Зњ",	"З™" => "Зљ",
	"З—" => "З",	"З•" => "З–",	"З“" => "З”",
	"З‘" => "З’",	"ЗЏ" => "Зђ",	"ЗЌ" => "ЗЋ",
	"ЗЉ" => "ЗЊ",	"З‡" => "З‰",	"З„" => "З†",
	"Жј" => "ЖЅ",	"Жё" => "Ж№",	"Ж·" => "К’",
	"Жµ" => "Ж¶",	"Жі" => "Жґ",	"ЖІ" => "К‹",
	"Ж±" => "КЉ",	"ЖЇ" => "Ж°",	"Ж®" => "К€",
	"Ж¬" => "Ж­",	"Ж©" => "Кѓ",	"Ж§" => "ЖЁ",
	"Ж¦" => "КЂ",	"Ж¤" => "ЖҐ",	"Жў" => "ЖЈ",
	"Ж " => "ЖЎ",	"Жџ" => "Йµ",	"Жќ" => "ЙІ",
	"Жњ" => "ЙЇ",	"Ж" => "Ж™",	"Ж—" => "ЙЁ",
	"Ж–" => "Й©",	"Ж”" => "ЙЈ",	"Ж“" => "Й ",
	"Ж‘" => "Ж’",	"Жђ" => "Й›",	"ЖЏ" => "Й™",
	"ЖЋ" => "Зќ",	"Ж‹" => "ЖЊ",	"ЖЉ" => "Й—",
	"Ж‰" => "Й–",	"Ж‡" => "Ж€",	"Ж†" => "Й”",
	"Ж„" => "Ж…",	"Ж‚" => "Жѓ",	"ЖЃ" => "Й“",
	"ЕЅ" => "Еѕ",	"Е»" => "Еј",	"Е№" => "Еє",
	"Её" => "Гї",	"Е¶" => "Е·",	"Еґ" => "Еµ",
	"ЕІ" => "Еі",	"Е°" => "Е±",	"Е®" => "ЕЇ",
	"Е¬" => "Е­",	"ЕЄ" => "Е«",	"ЕЁ" => "Е©",
	"Е¦" => "Е§",	"Е¤" => "ЕҐ",	"Еў" => "ЕЈ",
	"Е " => "ЕЎ",	"Ећ" => "Еџ",	"Ењ" => "Еќ",
	"Ељ" => "Е›",	"Е" => "Е™",	"Е–" => "Е—",
	"Е”" => "Е•",	"Е’" => "Е“",	"Еђ" => "Е‘",
	"ЕЋ" => "ЕЏ",	"ЕЊ" => "ЕЌ",	"ЕЉ" => "Е‹",
	"Е‡" => "Е€",	"Е…" => "Е†",	"Еѓ" => "Е„",
	"ЕЃ" => "Е‚",	"Дї" => "ЕЂ",	"ДЅ" => "Дѕ",
	"Д»" => "Дј",	"Д№" => "Дє",	"Д¶" => "Д·",
	"Дґ" => "Дµ",	"ДІ" => "Ді",	"Д°" => "i",
	"Д®" => "ДЇ",	"Д¬" => "Д­",	"ДЄ" => "Д«",
	"ДЁ" => "Д©",	"Д¦" => "Д§",	"Д¤" => "ДҐ",
	"Дў" => "ДЈ",	"Д " => "ДЎ",	"Дћ" => "Дџ",
	"Дњ" => "Дќ",	"Дљ" => "Д›",	"Д" => "Д™",
	"Д–" => "Д—",	"Д”" => "Д•",	"Д’" => "Д“",
	"Дђ" => "Д‘",	"ДЋ" => "ДЏ",	"ДЊ" => "ДЌ",
	"ДЉ" => "Д‹",	"Д€" => "Д‰",	"Д†" => "Д‡",
	"Д„" => "Д…",	"Д‚" => "Дѓ",	"ДЂ" => "ДЃ",
	"Гћ" => "Гѕ",	"Гќ" => "ГЅ",	"Гњ" => "Гј",
	"Г›" => "Г»",	"Гљ" => "Гє",	"Г™" => "Г№",
	"Г" => "Гё",	"Г–" => "Г¶",	"Г•" => "Гµ",
	"Г”" => "Гґ",	"Г“" => "Гі",	"Г’" => "ГІ",
	"Г‘" => "Г±",	"Гђ" => "Г°",	"ГЏ" => "ГЇ",
	"ГЋ" => "Г®",	"ГЌ" => "Г­",	"ГЊ" => "Г¬",
	"Г‹" => "Г«",	"ГЉ" => "ГЄ",	"Г‰" => "Г©",
	"Г€" => "ГЁ",	"Г‡" => "Г§",	"Г†" => "Г¦",
	"Г…" => "ГҐ",	"Г„" => "Г¤",	"Гѓ" => "ГЈ",
	"Г‚" => "Гў",	"ГЃ" => "ГЎ",	"ГЂ" => "Г ",
	"Z" => "z",		"Y" => "y",		"X" => "x",
	"W" => "w",		"V" => "v",		"U" => "u",
	"T" => "t",		"S" => "s",		"R" => "r",
	"Q" => "q",		"P" => "p",		"O" => "o",
	"N" => "n",		"M" => "m",		"L" => "l",
	"K" => "k",		"J" => "j",		"I" => "i",
	"H" => "h",		"G" => "g",		"F" => "f",
	"E" => "e",		"D" => "d",		"C" => "c",
	"B" => "b",		"A" => "a",
);


$UTF8_TABLES['strtoupper'] = array(
	"пЅљ" => "пјє",	"пЅ™" => "пј№",	"пЅ" => "пјё",
	"пЅ—" => "пј·",	"пЅ–" => "пј¶",	"пЅ•" => "пјµ",
	"пЅ”" => "пјґ",	"пЅ“" => "пјі",	"пЅ’" => "пјІ",
	"пЅ‘" => "пј±",	"пЅђ" => "пј°",	"пЅЏ" => "пјЇ",
	"пЅЋ" => "пј®",	"пЅЌ" => "пј­",	"пЅЊ" => "пј¬",
	"пЅ‹" => "пј«",	"пЅЉ" => "пјЄ",	"пЅ‰" => "пј©",
	"пЅ€" => "пјЁ",	"пЅ‡" => "пј§",	"пЅ†" => "пј¦",
	"пЅ…" => "пјҐ",	"пЅ„" => "пј¤",	"пЅѓ" => "пјЈ",
	"пЅ‚" => "пјў",	"пЅЃ" => "пјЎ",	"бїі" => "бїј",
	"бїҐ" => "бї¬",	"бїЎ" => "бї©",	"бї " => "бїЁ",
	"бї‘" => "бї™",	"бїђ" => "бї",	"бїѓ" => "бїЊ",
	"бѕѕ" => "О™",	"бѕі" => "бѕј",	"бѕ±" => "бѕ№",
	"бѕ°" => "бѕё",	"бѕ§" => "бѕЇ",	"бѕ¦" => "бѕ®",
	"бѕҐ" => "бѕ­",	"бѕ¤" => "бѕ¬",	"бѕЈ" => "бѕ«",
	"бѕў" => "бѕЄ",	"бѕЎ" => "бѕ©",	"бѕ " => "бѕЁ",
	"бѕ—" => "бѕџ",	"бѕ–" => "бѕћ",	"бѕ•" => "бѕќ",
	"бѕ”" => "бѕњ",	"бѕ“" => "бѕ›",	"бѕ’" => "бѕљ",
	"бѕ‘" => "бѕ™",	"бѕђ" => "бѕ",	"бѕ‡" => "бѕЏ",
	"бѕ†" => "бѕЋ",	"бѕ…" => "бѕЌ",	"бѕ„" => "бѕЊ",
	"бѕѓ" => "бѕ‹",	"бѕ‚" => "бѕЉ",	"бѕЃ" => "бѕ‰",
	"бѕЂ" => "бѕ€",	"бЅЅ" => "бї»",	"бЅј" => "бїє",
	"бЅ»" => "бї«",	"бЅє" => "бїЄ",	"бЅ№" => "бї№",
	"бЅё" => "бїё",	"бЅ·" => "бї›",	"бЅ¶" => "бїљ",
	"бЅµ" => "бї‹",	"бЅґ" => "бїЉ",	"бЅі" => "бї‰",
	"бЅІ" => "бї€",	"бЅ±" => "бѕ»",	"бЅ°" => "бѕє",
	"бЅ§" => "бЅЇ",	"бЅ¦" => "бЅ®",	"бЅҐ" => "бЅ­",
	"бЅ¤" => "бЅ¬",	"бЅЈ" => "бЅ«",	"бЅў" => "бЅЄ",
	"бЅЎ" => "бЅ©",	"бЅ " => "бЅЁ",	"бЅ—" => "бЅџ",
	"бЅ•" => "бЅќ",	"бЅ“" => "бЅ›",	"бЅ‘" => "бЅ™",
	"бЅ…" => "бЅЌ",	"бЅ„" => "бЅЊ",	"бЅѓ" => "бЅ‹",
	"бЅ‚" => "бЅЉ",	"бЅЃ" => "бЅ‰",	"бЅЂ" => "бЅ€",
	"бј·" => "бјї",	"бј¶" => "бјѕ",	"бјµ" => "бјЅ",
	"бјґ" => "бјј",	"бјі" => "бј»",	"бјІ" => "бјє",
	"бј±" => "бј№",	"бј°" => "бјё",	"бј§" => "бјЇ",
	"бј¦" => "бј®",	"бјҐ" => "бј­",	"бј¤" => "бј¬",
	"бјЈ" => "бј«",	"бјў" => "бјЄ",	"бјЎ" => "бј©",
	"бј " => "бјЁ",	"бј•" => "бјќ",	"бј”" => "бјњ",
	"бј“" => "бј›",	"бј’" => "бјљ",	"бј‘" => "бј™",
	"бјђ" => "бј",	"бј‡" => "бјЏ",	"бј†" => "бјЋ",
	"бј…" => "бјЌ",	"бј„" => "бјЊ",	"бјѓ" => "бј‹",
	"бј‚" => "бјЉ",	"бјЃ" => "бј‰",	"бјЂ" => "бј€",
	"б»№" => "б»ё",	"б»·" => "б»¶",	"б»µ" => "б»ґ",
	"б»і" => "б»І",	"б»±" => "б»°",	"б»Ї" => "б»®",
	"б»­" => "б»¬",	"б»«" => "б»Є",	"б»©" => "б»Ё",
	"б»§" => "б»¦",	"б»Ґ" => "б»¤",	"б»Ј" => "б»ў",
	"б»Ў" => "б» ",	"б»џ" => "б»ћ",	"б»ќ" => "б»њ",
	"б»›" => "б»љ",	"б»™" => "б»",	"б»—" => "б»–",
	"б»•" => "б»”",	"б»“" => "б»’",	"б»‘" => "б»ђ",
	"б»Џ" => "б»Ћ",	"б»Ќ" => "б»Њ",	"б»‹" => "б»Љ",
	"б»‰" => "б»€",	"б»‡" => "б»†",	"б»…" => "б»„",
	"б»ѓ" => "б»‚",	"б»Ѓ" => "б»Ђ",	"бєї" => "бєѕ",
	"бєЅ" => "бєј",	"бє»" => "бєє",	"бє№" => "бєё",
	"бє·" => "бє¶",	"бєµ" => "бєґ",	"бєі" => "бєІ",
	"бє±" => "бє°",	"бєЇ" => "бє®",	"бє­" => "бє¬",
	"бє«" => "бєЄ",	"бє©" => "бєЁ",	"бє§" => "бє¦",
	"бєҐ" => "бє¤",	"бєЈ" => "бєў",	"бєЎ" => "бє ",
	"бє›" => "б№ ",	"бє•" => "бє”",	"бє“" => "бє’",
	"бє‘" => "бєђ",	"бєЏ" => "бєЋ",	"бєЌ" => "бєЊ",
	"бє‹" => "бєЉ",	"бє‰" => "бє€",	"бє‡" => "бє†",
	"бє…" => "бє„",	"бєѓ" => "бє‚",	"бєЃ" => "бєЂ",
	"б№ї" => "б№ѕ",	"б№Ѕ" => "б№ј",	"б№»" => "б№є",
	"б№№" => "б№ё",	"б№·" => "б№¶",	"б№µ" => "б№ґ",
	"б№і" => "б№І",	"б№±" => "б№°",	"б№Ї" => "б№®",
	"б№­" => "б№¬",	"б№«" => "б№Є",	"б№©" => "б№Ё",
	"б№§" => "б№¦",	"б№Ґ" => "б№¤",	"б№Ј" => "б№ў",
	"б№Ў" => "б№ ",	"б№џ" => "б№ћ",	"б№ќ" => "б№њ",
	"б№›" => "б№љ",	"б№™" => "б№",	"б№—" => "б№–",
	"б№•" => "б№”",	"б№“" => "б№’",	"б№‘" => "б№ђ",
	"б№Џ" => "б№Ћ",	"б№Ќ" => "б№Њ",	"б№‹" => "б№Љ",
	"б№‰" => "б№€",	"б№‡" => "б№†",	"б№…" => "б№„",
	"б№ѓ" => "б№‚",	"б№Ѓ" => "б№Ђ",	"бёї" => "бёѕ",
	"бёЅ" => "бёј",	"бё»" => "бёє",	"бё№" => "бёё",
	"бё·" => "бё¶",	"бёµ" => "бёґ",	"бёі" => "бёІ",
	"бё±" => "бё°",	"бёЇ" => "бё®",	"бё­" => "бё¬",
	"бё«" => "бёЄ",	"бё©" => "бёЁ",	"бё§" => "бё¦",
	"бёҐ" => "бё¤",	"бёЈ" => "бёў",	"бёЎ" => "бё ",
	"бёџ" => "бёћ",	"бёќ" => "бёњ",	"бё›" => "бёљ",
	"бё™" => "бё",	"бё—" => "бё–",	"бё•" => "бё”",
	"бё“" => "бё’",	"бё‘" => "бёђ",	"бёЏ" => "бёЋ",
	"бёЌ" => "бёЊ",	"бё‹" => "бёЉ",	"бё‰" => "бё€",
	"бё‡" => "бё†",	"бё…" => "бё„",	"бёѓ" => "бё‚",
	"бёЃ" => "бёЂ",	"Ц†" => "Х–",	"Ц…" => "Х•",
	"Ц„" => "Х”",	"Цѓ" => "Х“",	"Ц‚" => "Х’",
	"ЦЃ" => "Х‘",	"ЦЂ" => "Хђ",	"Хї" => "ХЏ",
	"Хѕ" => "ХЋ",	"ХЅ" => "ХЌ",	"Хј" => "ХЊ",
	"Х»" => "Х‹",	"Хє" => "ХЉ",	"Х№" => "Х‰",
	"Хё" => "Х€",	"Х·" => "Х‡",	"Х¶" => "Х†",
	"Хµ" => "Х…",	"Хґ" => "Х„",	"Хі" => "Хѓ",
	"ХІ" => "Х‚",	"Х±" => "ХЃ",	"Х°" => "ХЂ",
	"ХЇ" => "Фї",	"Х®" => "Фѕ",	"Х­" => "ФЅ",
	"Х¬" => "Фј",	"Х«" => "Ф»",	"ХЄ" => "Фє",
	"Х©" => "Ф№",	"ХЁ" => "Фё",	"Х§" => "Ф·",
	"Х¦" => "Ф¶",	"ХҐ" => "Фµ",	"Х¤" => "Фґ",
	"ХЈ" => "Фі",	"Хў" => "ФІ",	"ХЎ" => "Ф±",
	"ФЏ" => "ФЋ",	"ФЌ" => "ФЊ",	"Ф‹" => "ФЉ",
	"Ф‰" => "Ф€",	"Ф‡" => "Ф†",	"Ф…" => "Ф„",
	"Фѓ" => "Ф‚",	"ФЃ" => "ФЂ",	"У№" => "Уё",
	"Уµ" => "Уґ",	"Уі" => "УІ",	"У±" => "У°",
	"УЇ" => "У®",	"У­" => "У¬",	"У«" => "УЄ",
	"У©" => "УЁ",	"У§" => "У¦",	"УҐ" => "У¤",
	"УЈ" => "Уў",	"УЎ" => "У ",	"Уџ" => "Ућ",
	"Уќ" => "Уњ",	"У›" => "Уљ",	"У™" => "У",
	"У—" => "У–",	"У•" => "У”",	"У“" => "У’",
	"У‘" => "Уђ",	"УЋ" => "УЌ",	"УЊ" => "У‹",
	"УЉ" => "У‰",	"У€" => "У‡",	"У†" => "У…",
	"У„" => "Уѓ",	"У‚" => "УЃ",	"Тї" => "Тѕ",
	"ТЅ" => "Тј",	"Т»" => "Тє",	"Т№" => "Тё",
	"Т·" => "Т¶",	"Тµ" => "Тґ",	"Ті" => "ТІ",
	"Т±" => "Т°",	"ТЇ" => "Т®",	"Т­" => "Т¬",
	"Т«" => "ТЄ",	"Т©" => "ТЁ",	"Т§" => "Т¦",
	"ТҐ" => "Т¤",	"ТЈ" => "Тў",	"ТЎ" => "Т ",
	"Тџ" => "Тћ",	"Тќ" => "Тњ",	"Т›" => "Тљ",
	"Т™" => "Т",	"Т—" => "Т–",	"Т•" => "Т”",
	"Т“" => "Т’",	"Т‘" => "Тђ",	"ТЏ" => "ТЋ",
	"ТЌ" => "ТЊ",	"Т‹" => "ТЉ",	"ТЃ" => "ТЂ",
	"Сї" => "Сѕ",	"СЅ" => "Сј",	"С»" => "Сє",
	"С№" => "Сё",	"С·" => "С¶",	"Сµ" => "Сґ",
	"Сі" => "СІ",	"С±" => "С°",	"СЇ" => "С®",
	"С­" => "С¬",	"С«" => "СЄ",	"С©" => "СЁ",
	"С§" => "С¦",	"СҐ" => "С¤",	"СЈ" => "Сў",
	"СЎ" => "С ",	"Сџ" => "РЏ",	"Сћ" => "РЋ",
	"Сќ" => "РЌ",	"Сњ" => "РЊ",	"С›" => "Р‹",
	"Сљ" => "РЉ",	"С™" => "Р‰",	"С" => "Р€",
	"С—" => "Р‡",	"С–" => "Р†",	"С•" => "Р…",
	"С”" => "Р„",	"С“" => "Рѓ",	"С’" => "Р‚",
	"С‘" => "РЃ",	"Сђ" => "РЂ",	"СЏ" => "РЇ",
	"СЋ" => "Р®",	"СЌ" => "Р­",	"СЊ" => "Р¬",
	"С‹" => "Р«",	"СЉ" => "РЄ",	"С‰" => "Р©",
	"С€" => "РЁ",	"С‡" => "Р§",	"С†" => "Р¦",
	"С…" => "РҐ",	"С„" => "Р¤",	"Сѓ" => "РЈ",
	"С‚" => "Рў",	"СЃ" => "РЎ",	"СЂ" => "Р ",
	"Рї" => "Рџ",	"Рѕ" => "Рћ",	"РЅ" => "Рќ",
	"Рј" => "Рњ",	"Р»" => "Р›",	"Рє" => "Рљ",
	"Р№" => "Р™",	"Рё" => "Р",	"Р·" => "Р—",
	"Р¶" => "Р–",	"Рµ" => "Р•",	"Рґ" => "Р”",
	"Рі" => "Р“",	"РІ" => "Р’",	"Р±" => "Р‘",
	"Р°" => "Рђ",	"Пµ" => "О•",	"ПІ" => "ОЈ",
	"П±" => "ОЎ",	"П°" => "Ољ",	"ПЇ" => "П®",
	"П­" => "П¬",	"П«" => "ПЄ",	"П©" => "ПЁ",
	"П§" => "П¦",	"ПҐ" => "П¤",	"ПЈ" => "Пў",
	"ПЎ" => "П ",	"Пџ" => "Пћ",	"Пќ" => "Пњ",
	"П›" => "Пљ",	"П™" => "П",	"П–" => "О ",
	"П•" => "О¦",	"П‘" => "О",	"Пђ" => "О’",
	"ПЋ" => "ОЏ",	"ПЌ" => "ОЋ",	"ПЊ" => "ОЊ",
	"П‹" => "О«",	"ПЉ" => "ОЄ",	"П‰" => "О©",
	"П€" => "ОЁ",	"П‡" => "О§",	"П†" => "О¦",
	"П…" => "ОҐ",	"П„" => "О¤",	"Пѓ" => "ОЈ",
	"П‚" => "ОЈ",	"ПЃ" => "ОЎ",	"ПЂ" => "О ",
	"Ої" => "Оџ",	"Оѕ" => "Оћ",	"ОЅ" => "Оќ",
	"Ој" => "Оњ",	"О»" => "О›",	"Оє" => "Ољ",
	"О№" => "О™",	"Оё" => "О",	"О·" => "О—",
	"О¶" => "О–",	"Оµ" => "О•",	"Оґ" => "О”",
	"Оі" => "О“",	"ОІ" => "О’",	"О±" => "О‘",
	"ОЇ" => "ОЉ",	"О®" => "О‰",	"О­" => "О€",
	"О¬" => "О†",	"К’" => "Ж·",	"К‹" => "ЖІ",
	"КЉ" => "Ж±",	"К€" => "Ж®",	"Кѓ" => "Ж©",
	"КЂ" => "Ж¦",	"Йµ" => "Жџ",	"ЙІ" => "Жќ",
	"ЙЇ" => "Жњ",	"Й©" => "Ж–",	"ЙЁ" => "Ж—",
	"ЙЈ" => "Ж”",	"Й " => "Ж“",	"Й›" => "Жђ",
	"Й™" => "ЖЏ",	"Й—" => "ЖЉ",	"Й–" => "Ж‰",
	"Й”" => "Ж†",	"Й“" => "ЖЃ",	"Иі" => "ИІ",
	"И±" => "И°",	"ИЇ" => "И®",	"И­" => "И¬",
	"И«" => "ИЄ",	"И©" => "ИЁ",	"И§" => "И¦",
	"ИҐ" => "И¤",	"ИЈ" => "Иў",	"Иџ" => "Ић",
	"Иќ" => "Ињ",	"И›" => "Иљ",	"И™" => "И",
	"И—" => "И–",	"И•" => "И”",	"И“" => "И’",
	"И‘" => "Иђ",	"ИЏ" => "ИЋ",	"ИЌ" => "ИЊ",
	"И‹" => "ИЉ",	"И‰" => "И€",	"И‡" => "И†",
	"И…" => "И„",	"Иѓ" => "И‚",	"ИЃ" => "ИЂ",
	"Зї" => "Зѕ",	"ЗЅ" => "Зј",	"З»" => "Зє",
	"З№" => "Зё",	"Зµ" => "Зґ",	"Зі" => "ЗІ",
	"ЗЇ" => "З®",	"З­" => "З¬",	"З«" => "ЗЄ",
	"З©" => "ЗЁ",	"З§" => "З¦",	"ЗҐ" => "З¤",
	"ЗЈ" => "Зў",	"ЗЎ" => "З ",	"Зџ" => "Зћ",
	"Зќ" => "ЖЋ",	"Зњ" => "З›",	"Зљ" => "З™",
	"З" => "З—",	"З–" => "З•",	"З”" => "З“",
	"З’" => "З‘",	"Зђ" => "ЗЏ",	"ЗЋ" => "ЗЌ",
	"ЗЊ" => "З‹",	"З‰" => "З€",	"З†" => "З…",
	"Жї" => "З·",	"ЖЅ" => "Жј",	"Ж№" => "Жё",
	"Ж¶" => "Жµ",	"Жґ" => "Жі",	"Ж°" => "ЖЇ",
	"Ж­" => "Ж¬",	"ЖЁ" => "Ж§",	"ЖҐ" => "Ж¤",
	"ЖЈ" => "Жў",	"ЖЎ" => "Ж ",	"Жћ" => "И ",
	"Ж™" => "Ж",	"Ж•" => "З¶",	"Ж’" => "Ж‘",
	"ЖЊ" => "Ж‹",	"Ж€" => "Ж‡",	"Ж…" => "Ж„",
	"Жѓ" => "Ж‚",	"Еї" => "S",	"Еѕ" => "ЕЅ",
	"Еј" => "Е»",	"Еє" => "Е№",	"Е·" => "Е¶",
	"Еµ" => "Еґ",	"Еі" => "ЕІ",	"Е±" => "Е°",
	"ЕЇ" => "Е®",	"Е­" => "Е¬",	"Е«" => "ЕЄ",
	"Е©" => "ЕЁ",	"Е§" => "Е¦",	"ЕҐ" => "Е¤",
	"ЕЈ" => "Еў",	"ЕЎ" => "Е ",	"Еџ" => "Ећ",
	"Еќ" => "Ењ",	"Е›" => "Ељ",	"Е™" => "Е",
	"Е—" => "Е–",	"Е•" => "Е”",	"Е“" => "Е’",
	"Е‘" => "Еђ",	"ЕЏ" => "ЕЋ",	"ЕЌ" => "ЕЊ",
	"Е‹" => "ЕЉ",	"Е€" => "Е‡",	"Е†" => "Е…",
	"Е„" => "Еѓ",	"Е‚" => "ЕЃ",	"ЕЂ" => "Дї",
	"Дѕ" => "ДЅ",	"Дј" => "Д»",	"Дє" => "Д№",
	"Д·" => "Д¶",	"Дµ" => "Дґ",	"Ді" => "ДІ",
	"Д±" => "I",	"ДЇ" => "Д®",	"Д­" => "Д¬",
	"Д«" => "ДЄ",	"Д©" => "ДЁ",	"Д§" => "Д¦",
	"ДҐ" => "Д¤",	"ДЈ" => "Дў",	"ДЎ" => "Д ",
	"Дџ" => "Дћ",	"Дќ" => "Дњ",	"Д›" => "Дљ",
	"Д™" => "Д",	"Д—" => "Д–",	"Д•" => "Д”",
	"Д“" => "Д’",	"Д‘" => "Дђ",	"ДЏ" => "ДЋ",
	"ДЌ" => "ДЊ",	"Д‹" => "ДЉ",	"Д‰" => "Д€",
	"Д‡" => "Д†",	"Д…" => "Д„",	"Дѓ" => "Д‚",
	"ДЃ" => "ДЂ",	"Гї" => "Её",	"Гѕ" => "Гћ",
	"ГЅ" => "Гќ",	"Гј" => "Гњ",	"Г»" => "Г›",
	"Гє" => "Гљ",	"Г№" => "Г™",	"Гё" => "Г",
	"Г¶" => "Г–",	"Гµ" => "Г•",	"Гґ" => "Г”",
	"Гі" => "Г“",	"ГІ" => "Г’",	"Г±" => "Г‘",
	"Г°" => "Гђ",	"ГЇ" => "ГЏ",	"Г®" => "ГЋ",
	"Г­" => "ГЌ",	"Г¬" => "ГЊ",	"Г«" => "Г‹",
	"ГЄ" => "ГЉ",	"Г©" => "Г‰",	"ГЁ" => "Г€",
	"Г§" => "Г‡",	"Г¦" => "Г†",	"ГҐ" => "Г…",
	"Г¤" => "Г„",	"ГЈ" => "Гѓ",	"Гў" => "Г‚",
	"ГЎ" => "ГЃ",	"Г " => "ГЂ",	"Вµ" => "Оњ",
	"z" => "Z",		"y" => "Y",		"x" => "X",
	"w" => "W",		"v" => "V",		"u" => "U",
	"t" => "T",		"s" => "S",		"r" => "R",
	"q" => "Q",		"p" => "P",		"o" => "O",
	"n" => "N",		"m" => "M",		"l" => "L",
	"k" => "K",		"j" => "J",		"i" => "I",
	"h" => "H",		"g" => "G",		"f" => "F",
	"e" => "E",		"d" => "D",		"c" => "C",
	"b" => "B",		"a" => "A",
);

class All_in_One_SEO_Pack {
	
 	var $version = "1.4.6.13";
 	
 	/** Max numbers of chars in auto-generated description */
 	var $maximum_description_length = 160;
 	
 	/** Minimum number of chars an excerpt should be so that it can be used
 	 * as description. Touch only if you know what you're doing
 	 */
 	var $minimum_description_length = 1;
 	
 	var $ob_start_detected = false;
 	
 	var $title_start = -1;
 	
 	var $title_end = -1;
 	
 	/** The title before rewriting */
 	var $orig_title = '';
 	
 	/** Temp filename for the latest version. */
 	var $upgrade_filename = 'temp.zip';
 	
 	/** Where to extract the downloaded newest version. */
 	var $upgrade_folder;
 	
 	/** Any error in upgrading. */
 	var $upgrade_error;
 	
 	/** Which zip to download in order to upgrade .*/
 	var $upgrade_url = 'http://downloads.wordpress.org/plugin/all-in-one-seo-pack.zip';
 	
 	/** Filename of log file. */
 	var $log_file;
 	
 	/** Flag whether there should be logging. */
 	var $do_log;
 	
 	var $wp_version;
 	
	function All_in_One_SEO_Pack() {
		global $wp_version;
		$this->wp_version = $wp_version;
		
		$this->log_file = dirname(__FILE__) . '/all_in_one_seo_pack.log';
		if (get_option('aiosp_do_log')) {
			$this->do_log = true;
		} else {
			$this->do_log = false;
		}

		$this->upgrade_filename = dirname(__FILE__) . '/' . $this->upgrade_filename;
		$this->upgrade_folder = dirname(__FILE__);
	}
	
	/**      
	 * Convert a string to lower case
	 * Compatible with mb_strtolower(), an UTF-8 friendly replacement for strtolower()
	 */
	function strtolower($str) {
		global $UTF8_TABLES;
		return strtr($str, $UTF8_TABLES['strtolower']);
	}
	
	/**      
	 * Convert a string to upper case
	 * Compatible with mb_strtoupper(), an UTF-8 friendly replacement for strtoupper()
	 */
	function strtoupper($str) {
		global $UTF8_TABLES;
		return strtr($str, $UTF8_TABLES['strtoupper']);
	}	
	
	
	function template_redirect() {
		global $wp_query;
		$post = $wp_query->get_queried_object();

		if (is_feed()) {
			return;
		}

		if (is_single() || is_page()) {
		    $aiosp_disable = htmlspecialchars(stripcslashes(get_post_meta($post->ID, 'aiosp_disable', true)));
		    if ($aiosp_disable) {
		    	return;
		    }
		}

		if (get_option('aiosp_rewrite_titles')) {
			ob_start(array($this, 'output_callback_for_title'));
		}
	}
	
	function output_callback_for_title($content) {
		return $this->rewrite_title($content);
	}

	function init() {
		if (function_exists('load_plugin_textdomain')) {
			load_plugin_textdomain('all_in_one_seo_pack', 'wp-content/plugins/all-in-one-seo-pack');
		}
	}

	function is_static_front_page() {
		global $wp_query;
		$post = $wp_query->get_queried_object();
		return get_option('show_on_front') == 'page' && is_page() && $post->ID == get_option('page_on_front');
	}
	
	function is_static_posts_page() {
		global $wp_query;
		$post = $wp_query->get_queried_object();
		return get_option('show_on_front') == 'page' && is_home() && $post->ID == get_option('page_for_posts');
	}
	
	function get_base() {
   		 return '/'.end(explode('/', str_replace(array('\\','/all_in_one_seo_pack.php'),array('/',''),__FILE__)));
	}

	function admin_head() {
		$home = get_settings('siteurl');
		$stylesheet = $home.'/wp-content/plugins' . $this->get_base() . '/css/all_in_one_seo_pack.css';
		echo('<link rel="stylesheet" href="' . $stylesheet . '" type="text/css" media="screen" />');
	}
	
	function wp_head() {
		if (is_feed()) {
			return;
		}
		
		global $wp_query;
		$post = $wp_query->get_queried_object();
		$meta_string = null;
		
		//echo("wp_head() " . wp_title('', false) . " is_home() => " . is_home() . ", is_page() => " . is_page() . ", is_single() => " . is_single() . ", is_static_front_page() => " . $this->is_static_front_page() . ", is_static_posts_page() => " . $this->is_static_posts_page());

		if (is_single() || is_page()) {
		    $aiosp_disable = htmlspecialchars(stripcslashes(get_post_meta($post->ID, 'aiosp_disable', true)));
		    if ($aiosp_disable) {
		    	return;
		    }
		}
		
		if (get_option('aiosp_rewrite_titles')) {
			// make the title rewrite as short as possible
			if (function_exists('ob_list_handlers')) {
				$active_handlers = ob_list_handlers();
			} else {
				$active_handlers = array();
			}
			if (sizeof($active_handlers) > 0 &&
				strtolower($active_handlers[sizeof($active_handlers) - 1]) ==
				strtolower('All_in_One_SEO_Pack::output_callback_for_title')) {
				ob_end_flush();
			} else {
				$this->log("another plugin interfering?");
				// if we get here there *could* be trouble with another plugin :(
				$this->ob_start_detected = true;
				if (function_exists('ob_list_handlers')) {
					foreach (ob_list_handlers() as $handler) {
						$this->log("detected output handler $handler");
					}
				}
			}
		}
		
		echo "\n<!-- all in one seo pack $this->version ";
		if ($this->ob_start_detected) {
			echo "ob_start_detected ";
		}
		echo "[$this->title_start,$this->title_end] ";
		echo "-->\n";
		
		if ((is_home() && get_option('aiosp_home_keywords')) || $this->is_static_front_page()) {
			$keywords = trim($this->internationalize(get_option('aiosp_home_keywords')));
		} else {
			$keywords = $this->get_all_keywords();
		}
		if (is_single() || is_page()) {
            if ($this->is_static_front_page()) {
				$description = trim(stripcslashes($this->internationalize(get_option('aiosp_home_description'))));
            } else {
            	$description = $this->get_post_description($post);
            }
		} else if (is_home()) {
			$description = trim(stripcslashes($this->internationalize(get_option('aiosp_home_description'))));
		} else if (is_category()) {
			$description = $this->internationalize(category_description());
		}
		
		if (isset($description) && (strlen($description) > $this->minimum_description_length) && !(is_home() && is_paged())) {
			$description = trim(strip_tags($description));
			$description = str_replace('"', '', $description);
			
			// replace newlines on mac / windows?
			$description = str_replace("\r\n", ' ', $description);
			
			// maybe linux uses this alone
			$description = str_replace("\n", ' ', $description);
			
			if (isset($meta_string)) {
				//$meta_string .= "\n";
			} else {
				$meta_string = '';
			}
			
			// description format
            $description_format = get_option('aiosp_description_format');
            if (!isset($description_format) || empty($description_format)) {
            	$description_format = "%description%";
            }
            $description = str_replace('%description%', $description, $description_format);
            $description = str_replace('%blog_title%', get_bloginfo('name'), $description);
            $description = str_replace('%blog_description%', get_bloginfo('description'), $description);
            $description = str_replace('%wp_title%', $this->get_original_title(), $description);
            
            $meta_string .= sprintf("<meta name=\"description\" content=\"%s\" />", $description);
		}

		if (isset ($keywords) && !empty($keywords) && !(is_home() && is_paged())) {
			if (isset($meta_string)) {
				$meta_string .= "\n";
			}
			$meta_string .= sprintf("<meta name=\"keywords\" content=\"%s\" />", $keywords);
		}

		if (function_exists('is_tag')) {
			$is_tag = is_tag();
		}
		
		if ((is_category() && get_option('aiosp_category_noindex')) ||
			(!is_category() && is_archive() &&!$is_tag && get_option('aiosp_archive_noindex')) ||
			(get_option('aiosp_tags_noindex') && $is_tag)) {
			if (isset($meta_string)) {
				$meta_string .= "\n";
			}
			$meta_string .= '<meta name="robots" content="noindex,follow" />';
		}
		
		$page_meta = stripcslashes(get_option('aiosp_page_meta_tags'));
		$post_meta = stripcslashes(get_option('aiosp_post_meta_tags'));
		$home_meta = stripcslashes(get_option('aiosp_home_meta_tags'));
		if (is_page() && isset($page_meta) && !empty($page_meta)) {
			if (isset($meta_string)) {
				$meta_string .= "\n";
			}
			echo "\n$page_meta";
		}
		
		if (is_single() && isset($post_meta) && !empty($post_meta)) {
			if (isset($meta_string)) {
				$meta_string .= "\n";
			}
			$meta_string .= "$post_meta";
		}
		
		if (is_home() && !empty($home_meta)) {
			if (isset($meta_string)) {
				$meta_string .= "\n";
			}
			$meta_string .= "$home_meta";
		}
		
		if ($meta_string != null) {
			echo "$meta_string\n";
		}
		
		echo "<!-- /all in one seo pack -->\n";
	}
	
	function get_post_description($post) {
	    $description = trim(stripcslashes($this->internationalize(get_post_meta($post->ID, "description", true))));
		if (!$description) {
			$description = $this->trim_excerpt_without_filters_full_length($this->internationalize($post->post_excerpt));
			if (!$description && get_option("aiosp_generate_descriptions")) {
				$description = $this->trim_excerpt_without_filters($this->internationalize($post->post_content));
			}				
		}
		
		// "internal whitespace trim"
		$description = preg_replace("/\s\s+/", " ", $description);
		
		return $description;
	}
	
	function replace_title($content, $title) {
		$title = trim(strip_tags($title));
		
		$title_tag_start = "<title>";
		$title_tag_end = "</title>";
		$len_start = strlen($title_tag_start);
		$len_end = strlen($title_tag_end);
		$title = stripcslashes(trim($title));
		$start = strpos($content, $title_tag_start);
		$end = strpos($content, $title_tag_end);
		
		$this->title_start = $start;
		$this->title_end = $end;
		$this->orig_title = $title;
		
		if ($start && $end) {
			$header = substr($content, 0, $start + $len_start) . $title .  substr($content, $end);
		} else {
			// this breaks some sitemap plugins (like wpg2)
			//$header = $content . "<title>$title</title>";
			
			$header = $content;
		}
		
		return $header;
	}
	
	function internationalize($in) {
		if (function_exists('langswitch_filter_langs_with_message')) {
			$in = langswitch_filter_langs_with_message($in);
		}
		if (function_exists('polyglot_filter')) {
			$in = polyglot_filter($in);
		}
		if (function_exists('qtrans_useCurrentLanguageIfNotFoundUseDefaultLanguage')) {
			$in = qtrans_useCurrentLanguageIfNotFoundUseDefaultLanguage($in);
		}
		$in = apply_filters('localization', $in);
		return $in;
	}
	
	/** @return The original title as delivered by WP (well, in most cases) */
	function get_original_title() {
		global $wp_query;
		if (!$wp_query) {
			return null;	
		}
		
		$post = $wp_query->get_queried_object();
		
		// the_search_query() is not suitable, it cannot just return
		global $s;
		
		$title = null;
		
		if (is_home()) {
			$title = get_option('blogname');
		} else if (is_single()) {
			$title = $this->internationalize(wp_title('', false));
		} else if (is_search() && isset($s) && !empty($s)) {
			if (function_exists('attribute_escape')) {
				$search = attribute_escape(stripcslashes($s));
			} else {
				$search = wp_specialchars(stripcslashes($s), true);
			}
			$search = $this->capitalize($search);
			$title = $search;
		} else if (is_category() && !is_feed()) {
			$category_description = $this->internationalize(category_description());
			$category_name = ucwords($this->internationalize(single_cat_title('', false)));
			$title = $category_name;
		} else if (is_page()) {
			$title = $this->internationalize(wp_title('', false));
		} else if (function_exists('is_tag') && is_tag()) {
			global $utw;
			if ($utw) {
				$tags = $utw->GetCurrentTagSet();
				$tag = $tags[0]->tag;
		        $tag = str_replace('-', ' ', $tag);
			} else {
				// wordpress > 2.3
				$tag = $this->internationalize(wp_title('', false));
			}
			if ($tag) {
				$title = $tag;
			}
		} else if (is_archive()) {
			$title = $this->internationalize(wp_title('', false));
		} else if (is_404()) {
		    $title_format = get_option('aiosp_404_title_format');
		    $new_title = str_replace('%blog_title%', $this->internationalize(get_bloginfo('name')), $title_format);
		    $new_title = str_replace('%blog_description%', $this->internationalize(get_bloginfo('description')), $new_title);
		    $new_title = str_replace('%request_url%', $_SERVER['REQUEST_URI'], $new_title);
		    $new_title = str_replace('%request_words%', $this->request_as_words($_SERVER['REQUEST_URI']), $new_title);
				$title = $new_title;
			}
			
			return trim($title);
		}
	
	function paged_title($title) {
		// the page number if paged
		global $paged;
		
		// simple tagging support
		global $STagging;

		if (is_paged() || (isset($STagging) && $STagging->is_tag_view() && $paged)) {
			$part = $this->internationalize(get_option('aiosp_paged_format'));
			if (isset($part) || !empty($part)) {
				$part = " " . trim($part);
				$part = str_replace('%page%', $paged, $part);
				$this->log("paged_title() [$title] [$part]");
				$title .= $part;
			}
		}
		return $title;
	}

	function rewrite_title($header) {
		global $wp_query;
		if (!$wp_query) {
			$header .= "<!-- no wp_query found! -->\n";
			return $header;	
		}
		
		$post = $wp_query->get_queried_object();
		
		// the_search_query() is not suitable, it cannot just return
		global $s;
		
		// simple tagging support
		global $STagging;

		if (is_home()) {
			$title = $this->internationalize(get_option('aiosp_home_title'));
			if (empty($title)) {
				$title = $this->internationalize(get_option('blogname'));
			}
			$title = $this->paged_title($title);
			$header = $this->replace_title($header, $title);
		} else if (is_single()) {
			// we're not in the loop :(
			$authordata = get_userdata($post->post_author);
			$categories = get_the_category();
			$category = '';
			if (count($categories) > 0) {
				$category = $categories[0]->cat_name;
			}
			$title = $this->internationalize(get_post_meta($post->ID, "title", true));
			if (!$title) {
				$title = $this->internationalize(get_post_meta($post->ID, "title_tag", true));
				if (!$title) {
					$title = $this->internationalize(wp_title('', false));
				}
			}
            $title_format = get_option('aiosp_post_title_format');
            $new_title = str_replace('%blog_title%', $this->internationalize(get_bloginfo('name')), $title_format);
            $new_title = str_replace('%blog_description%', $this->internationalize(get_bloginfo('description')), $new_title);
            $new_title = str_replace('%post_title%', $title, $new_title);
            $new_title = str_replace('%category%', $category, $new_title);
            $new_title = str_replace('%category_title%', $category, $new_title);
            $new_title = str_replace('%post_author_login%', $authordata->user_login, $new_title);
            $new_title = str_replace('%post_author_nicename%', $authordata->user_nicename, $new_title);
            $new_title = str_replace('%post_author_firstname%', ucwords($authordata->first_name), $new_title);
            $new_title = str_replace('%post_author_lastname%', ucwords($authordata->last_name), $new_title);
			$title = $new_title;
			$title = trim($title);
			$header = $this->replace_title($header, $title);
		} else if (is_search() && isset($s) && !empty($s)) {
			if (function_exists('attribute_escape')) {
				$search = attribute_escape(stripcslashes($s));
			} else {
				$search = wp_specialchars(stripcslashes($s), true);
			}
			$search = $this->capitalize($search);
            $title_format = get_option('aiosp_search_title_format');
            $title = str_replace('%blog_title%', $this->internationalize(get_bloginfo('name')), $title_format);
            $title = str_replace('%blog_description%', $this->internationalize(get_bloginfo('description')), $title);
            $title = str_replace('%search%', $search, $title);
			$header = $this->replace_title($header, $title);
		} else if (is_category() && !is_feed()) {
			$category_description = $this->internationalize(category_description());
			$category_name = ucwords($this->internationalize(single_cat_title('', false)));
            $title_format = get_option('aiosp_category_title_format');
            $title = str_replace('%category_title%', $category_name, $title_format);
            $title = str_replace('%category_description%', $category_description, $title);
            $title = str_replace('%blog_title%', $this->internationalize(get_bloginfo('name')), $title);
            $title = str_replace('%blog_description%', $this->internationalize(get_bloginfo('description')), $title);
            $title = $this->paged_title($title);
			$header = $this->replace_title($header, $title);
		} else if (is_page()) {
			// we're not in the loop :(
			$authordata = get_userdata($post->post_author);
			if ($this->is_static_front_page()) {
				if ($this->internationalize(get_option('aiosp_home_title'))) {
					$header = $this->replace_title($header, $this->internationalize(get_option('aiosp_home_title')));
				}
			} else {
				$title = $this->internationalize(get_post_meta($post->ID, "title", true));
				if (!$title) {
					$title = $this->internationalize(wp_title('', false));
				}
	            $title_format = get_option('aiosp_page_title_format');
	            $new_title = str_replace('%blog_title%', $this->internationalize(get_bloginfo('name')), $title_format);
	            $new_title = str_replace('%blog_description%', $this->internationalize(get_bloginfo('description')), $new_title);
	            $new_title = str_replace('%page_title%', $title, $new_title);
	            $new_title = str_replace('%page_author_login%', $authordata->user_login, $new_title);
	            $new_title = str_replace('%page_author_nicename%', $authordata->user_nicename, $new_title);
	            $new_title = str_replace('%page_author_firstname%', ucwords($authordata->first_name), $new_title);
	            $new_title = str_replace('%page_author_lastname%', ucwords($authordata->last_name), $new_title);
				$title = trim($new_title);
				$header = $this->replace_title($header, $title);
			}
		} else if (function_exists('is_tag') && is_tag()) {
			global $utw;
			if ($utw) {
				$tags = $utw->GetCurrentTagSet();
				$tag = $tags[0]->tag;
	            $tag = str_replace('-', ' ', $tag);
			} else {
				// wordpress > 2.3
				$tag = $this->internationalize(wp_title('', false));
			}
			if ($tag) {
	            $tag = $this->capitalize($tag);
	            $title_format = get_option('aiosp_tag_title_format');
	            $title = str_replace('%blog_title%', $this->internationalize(get_bloginfo('name')), $title_format);
	            $title = str_replace('%blog_description%', $this->internationalize(get_bloginfo('description')), $title);
	            $title = str_replace('%tag%', $tag, $title);
	            $title = $this->paged_title($title);
				$header = $this->replace_title($header, $title);
			}
		} else if (isset($STagging) && $STagging->is_tag_view()) { // simple tagging support
			$tag = $STagging->search_tag;
			if ($tag) {
	            $tag = $this->capitalize($tag);
	            $title_format = get_option('aiosp_tag_title_format');
	            $title = str_replace('%blog_title%', $this->internationalize(get_bloginfo('name')), $title_format);
	            $title = str_replace('%blog_description%', $this->internationalize(get_bloginfo('description')), $title);
	            $title = str_replace('%tag%', $tag, $title);
	            $title = $this->paged_title($title);
				$header = $this->replace_title($header, $title);
			}
		} else if (is_archive()) {
			$date = $this->internationalize(wp_title('', false));
            $title_format = get_option('aiosp_archive_title_format');
            $new_title = str_replace('%blog_title%', $this->internationalize(get_bloginfo('name')), $title_format);
            $new_title = str_replace('%blog_description%', $this->internationalize(get_bloginfo('description')), $new_title);
            $new_title = str_replace('%date%', $date, $new_title);
			$title = trim($new_title);
            $title = $this->paged_title($title);
			$header = $this->replace_title($header, $title);
		} else if (is_404()) {
            $title_format = get_option('aiosp_404_title_format');
            $new_title = str_replace('%blog_title%', $this->internationalize(get_bloginfo('name')), $title_format);
            $new_title = str_replace('%blog_description%', $this->internationalize(get_bloginfo('description')), $new_title);
            $new_title = str_replace('%request_url%', $_SERVER['REQUEST_URI'], $new_title);
            $new_title = str_replace('%request_words%', $this->request_as_words($_SERVER['REQUEST_URI']), $new_title);
			$header = $this->replace_title($header, $new_title);
		}
		
		return $header;

	}
	
	/**
	 * @return User-readable nice words for a given request.
	 */
	function request_as_words($request) {
		$request = htmlspecialchars($request);
		$request = str_replace('.html', ' ', $request);
		$request = str_replace('.htm', ' ', $request);
		$request = str_replace('.', ' ', $request);
		$request = str_replace('/', ' ', $request);
		$request_a = explode(' ', $request);
		$request_new = array();
		foreach ($request_a as $token) {
			$request_new[] = ucwords(trim($token));
		}
		$request = implode(' ', $request_new);
		return $request;
	}
	
	function capitalize($s) {
		$s = trim($s);
		$tokens = explode(' ', $s);
		while (list($key, $val) = each($tokens)) {
			$tokens[$key] = trim($tokens[$key]);
			$tokens[$key] = strtoupper(substr($tokens[$key], 0, 1)) . substr($tokens[$key], 1);
		}
		$s = implode(' ', $tokens);
		return $s;
	}
	
	function trim_excerpt_without_filters($text) {
		$text = str_replace(']]>', ']]&gt;', $text);
		$text = strip_tags($text);
		$max = $this->maximum_description_length;
		
		if ($max < strlen($text)) {
			while($text[$max] != ' ' && $max > $this->minimum_description_length) {
				$max--;
			}
		}
		$text = substr($text, 0, $max);
		return trim(stripcslashes($text));
	}
	
	function trim_excerpt_without_filters_full_length($text) {
		$text = str_replace(']]>', ']]&gt;', $text);
		$text = strip_tags($text);
		return trim(stripcslashes($text));
	}
	
	/**
	 * @return comma-separated list of unique keywords
	 */
	function get_all_keywords() {
		global $posts;

		if (is_404()) {
			return null;
		}
		
		// if we are on synthetic pages
		if (!is_home() && !is_page() && !is_single() &&!$this->is_static_front_page() && !$this->is_static_posts_page()) {
			return null;
		}

	    $keywords = array();
	    if (is_array($posts)) {
	        foreach ($posts as $post) {
	            if ($post) {

	                // custom field keywords
	                $keywords_a = $keywords_i = null;
	                $description_a = $description_i = null;
	                $id = $post->ID;
		            $keywords_i = stripcslashes($this->internationalize(get_post_meta($post->ID, "keywords", true)));
	                $keywords_i = str_replace('"', '', $keywords_i);
	                if (isset($keywords_i) && !empty($keywords_i)) {
	                	$traverse = explode(',', $keywords_i);
	                	foreach ($traverse as $keyword) {
	                		$keywords[] = $keyword;
	                	}
	                }
	                
	                // WP 2.3 tags
	                if (function_exists('get_the_tags')) {
	                	$tags = get_the_tags($post->ID);
	                	if ($tags && is_array($tags)) {
		                	foreach ($tags as $tag) {
		                		$keywords[] = $this->internationalize($tag->name);
		                	}
	                	}
	                }

	                // Ultimate Tag Warrior integration
	                global $utw;
	                if ($utw) {
	                	$tags = $utw->GetTagsForPost($post);
	                	if (is_array($tags)) {
		                	foreach ($tags as $tag) {
								$tag = $tag->tag;
								$tag = str_replace('_',' ', $tag);
								$tag = str_replace('-',' ',$tag);
								$tag = stripcslashes($tag);
		                		$keywords[] = $tag;
		                	}
	                	}
	                }
	                
	                // autometa
	                $autometa = stripcslashes(get_post_meta($post->ID, "autometa", true));
	                if (isset($autometa) && !empty($autometa)) {
	                	$autometa_array = explode(' ', $autometa);
	                	foreach ($autometa_array as $e) {
	                		$keywords[] = $e;
	                	}
	                }

	            	if (get_option('aiosp_use_categories') && !is_page()) {
		                $categories = get_the_category($post->ID);
		                foreach ($categories as $category) {
		                	$keywords[] = $this->internationalize($category->cat_name);
		                }
	            	}

	            }
	        }
	    }
	    
	    return $this->get_unique_keywords($keywords);
	}
	
	function get_meta_keywords() {
		global $posts;

	    $keywords = array();
	    if (is_array($posts)) {
	        foreach ($posts as $post) {
	            if ($post) {
	                // custom field keywords
	                $keywords_a = $keywords_i = null;
	                $description_a = $description_i = null;
	                $id = $post->ID;
		            $keywords_i = stripcslashes(get_post_meta($post->ID, "keywords", true));
	                $keywords_i = str_replace('"', '', $keywords_i);
	                if (isset($keywords_i) && !empty($keywords_i)) {
	                    $keywords[] = $keywords_i;
	                }
	            }
	        }
	    }
	    
	    return $this->get_unique_keywords($keywords);
	}
	
	function get_unique_keywords($keywords) {
		$small_keywords = array();
		foreach ($keywords as $word) {
			if (function_exists('mb_strtolower'))			
				$small_keywords[] = mb_strtolower($word);
			else 
				$small_keywords[] = $this->strtolower($word);
		}
		$keywords_ar = array_unique($small_keywords);
		return implode(',', $keywords_ar);
	}
	
	function get_url($url)	{
		if (function_exists('file_get_contents')) {
			$file = file_get_contents($url);
		} else {
	        $curl = curl_init($url);
	        curl_setopt($curl, CURLOPT_HEADER, 0);
	        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
	        $file = curl_exec($curl);
	        curl_close($curl);
	    }
	    return $file;
	}
	
	function log($message) {
		if ($this->do_log) {
			error_log(date('Y-m-d H:i:s') . " " . $message . "\n", 3, $this->log_file);
		}
	}

	function download_newest_version() {
		$success = true;
	    $file_content = $this->get_url($this->upgrade_url);
	    if ($file_content === false) {
	    	$this->upgrade_error = sprintf(__("Could not download distribution (%s)"), $this->upgrade_url);
			$success = false;
	    } else if (strlen($file_content) < 100) {
	    	$this->upgrade_error = sprintf(__("Could not download distribution (%s): %s"), $this->upgrade_url, $file_content);
			$success = false;
	    } else {
	    	$this->log(sprintf("filesize of download ZIP: %d", strlen($file_content)));
		    $fh = @fopen($this->upgrade_filename, 'w');
		    $this->log("fh is $fh");
		    if (!$fh) {
		    	$this->upgrade_error = sprintf(__("Could not open %s for writing"), $this->upgrade_filename);
		    	$this->upgrade_error .= "<br />";
		    	$this->upgrade_error .= sprintf(__("Please make sure %s is writable"), $this->upgrade_folder);
		    	$success = false;
		    } else {
		    	$bytes_written = @fwrite($fh, $file_content);
			    $this->log("wrote $bytes_written bytes");
		    	if (!$bytes_written) {
			    	$this->upgrade_error = sprintf(__("Could not write to %s"), $this->upgrade_filename);
			    	$success = false;
		    	}
		    }
		    if ($success) {
		    	fclose($fh);
		    }
	    }
	    return $success;
	}

	function install_newest_version() {
		$success = $this->download_newest_version();
	    if ($success) {
		    $success = $this->extract_plugin();
		    unlink($this->upgrade_filename);
	    }
	    return $success;
	}

	function extract_plugin() {
	    if (!class_exists('PclZip')) {
	        require_once ('pclzip.lib.php');
	    }
	    $archive = new PclZip($this->upgrade_filename);
	    $files = $archive->extract(PCLZIP_OPT_STOP_ON_ERROR, PCLZIP_OPT_REPLACE_NEWER, PCLZIP_OPT_REMOVE_ALL_PATH, PCLZIP_OPT_PATH, $this->upgrade_folder);
	    $this->log("files is $files");
	    if (is_array($files)) {
	    	$num_extracted = sizeof($files);
		    $this->log("extracted $num_extracted files to $this->upgrade_folder");
		    $this->log(print_r($files, true));
	    	return true;
	    } else {
	    	$this->upgrade_error = $archive->errorInfo();
	    	return false;
	    }
	}
	
	/** crude approximization of whether current user is an admin */
	function is_admin() {
		return current_user_can('level_8');
	}
	
	function is_directory_writable($directory) {
		$filename = $directory . '/' . 'tmp_file_' . time();
		$fh = @fopen($filename, 'w');
		if (!$fh) {
			return false;
		}
		
		$written = fwrite($fh, "test");
		fclose($fh);
		unlink($filename);
		if ($written) {
			return true;
		} else {
			return false;
		}
	}

	function is_upgrade_directory_writable() {
		//return $this->is_directory_writable($this->upgrade_folder);
		// let's assume it is
		return true;
	}

	function post_meta_tags($id) {
	    $awmp_edit = $_POST["aiosp_edit"];
	    if (isset($awmp_edit) && !empty($awmp_edit)) {
		    $keywords = $_POST["aiosp_keywords"];
		    $description = $_POST["aiosp_description"];
		    $title = $_POST["aiosp_title"];
		    $aiosp_meta = $_POST["aiosp_meta"];
		    $aiosp_disable = $_POST["aiosp_disable"];

		    delete_post_meta($id, 'keywords');
		    delete_post_meta($id, 'description');
		    delete_post_meta($id, 'title');
		    if ($this->is_admin()) {
		    	delete_post_meta($id, 'aiosp_disable');
		    }
		    //delete_post_meta($id, 'aiosp_meta');

		    if (isset($keywords) && !empty($keywords)) {
			    add_post_meta($id, 'keywords', $keywords);
		    }
		    if (isset($description) && !empty($description)) {
			    add_post_meta($id, 'description', $description);
		    }
		    if (isset($title) && !empty($title)) {
			    add_post_meta($id, 'title', $title);
		    }
		    if (isset($aiosp_disable) && !empty($aiosp_disable) && $this->is_admin()) {
			    add_post_meta($id, 'aiosp_disable', $aiosp_disable);
		    }
		    /*
		    if (isset($aiosp_meta) && !empty($aiosp_meta)) {
			    add_post_meta($id, 'aiosp_meta', $aiosp_meta);
		    }
		    */
	    }
	}

	function edit_category($id) {
		global $wpdb;
		$id = $wpdb->escape($id);
	    $awmp_edit = $_POST["aiosp_edit"];
	    if (isset($awmp_edit) && !empty($awmp_edit)) {
		    $keywords = $wpdb->escape($_POST["aiosp_keywords"]);
		    $title = $wpdb->escape($_POST["aiosp_title"]);
		    $old_category = $wpdb->get_row("select * from $this->table_categories where category_id=$id", OBJECT);
		    if ($old_category) {
		    	$wpdb->query("update $this->table_categories
		    			set meta_title='$title', meta_keywords='$keywords'
		    			where category_id=$id");
		    } else {
		    	$wpdb->query("insert into $this->table_categories(meta_title, meta_keywords, category_id)
		    			values ('$title', '$keywords', $id");
		    }
		    //$wpdb->query("insert into $this->table_categories")
	    	/*
		    delete_post_meta($id, 'keywords');
		    delete_post_meta($id, 'description');
		    delete_post_meta($id, 'title');

		    if (isset($keywords) && !empty($keywords)) {
			    add_post_meta($id, 'keywords', $keywords);
		    }
		    if (isset($description) && !empty($description)) {
			    add_post_meta($id, 'description', $description);
		    }
		    if (isset($title) && !empty($title)) {
			    add_post_meta($id, 'title', $title);
		    }
		    */
	    }
	}

	/**
	 * @deprecated This was for the feature of dedicated meta tags for categories which never went mainstream.
	 */
	function edit_category_form() {
	    global $post;
	    $keywords = stripcslashes(get_post_meta($post->ID, 'keywords', true));
	    $title = stripcslashes(get_post_meta($post->ID, 'title', true));
	    $description = stripcslashes(get_post_meta($post->ID, 'description', true));
		?>
		<input value="aiosp_edit" type="hidden" name="aiosp_edit" />
		<table class="editform" width="100%" cellspacing="2" cellpadding="5">
		<tr>
		<th width="33%" scope="row" valign="top">
		<a href="http://wp.uberdose.com/2007/03/24/all-in-one-seo-pack/"><?php _e('All in One SEO Pack', 'all_in_one_seo_pack') ?></a>
		</th>
		</tr>
		<tr>
		<th width="33%" scope="row" valign="top"><label for="aiosp_title"><?php _e('Title:', 'all_in_one_seo_pack') ?></label></th>
		<td><input value="<?php echo $title ?>" type="text" name="aiosp_title" size="70"/></td>
		</tr>
		<tr>
		<th width="33%" scope="row" valign="top"><label for="aiosp_keywords"><?php _e('Keywords (comma separated):', 'all_in_one_seo_pack') ?></label></th>
		<td><input value="<?php echo $keywords ?>" type="text" name="aiosp_keywords" size="70"/></td>
		</tr>
		</table>
		<?php
	}

	function add_meta_tags_textinput() {
	    global $post;
	    $post_id = $post;
	    if (is_object($post_id)) {
	    	$post_id = $post_id->ID;
	    }
	    $keywords = htmlspecialchars(stripcslashes(get_post_meta($post_id, 'keywords', true)));
	    $title = htmlspecialchars(stripcslashes(get_post_meta($post_id, 'title', true)));
	    $description = htmlspecialchars(stripcslashes(get_post_meta($post_id, 'description', true)));
	    $aiosp_meta = htmlspecialchars(stripcslashes(get_post_meta($post_id, 'aiosp_meta', true)));
	    $aiosp_disable = htmlspecialchars(stripcslashes(get_post_meta($post_id, 'aiosp_disable', true)));
		?>
		<SCRIPT LANGUAGE="JavaScript">
		<!-- Begin
		function countChars(field,cntfield) {
		cntfield.value = field.value.length;
		}
		//  End -->
		</script>

	 <?php if (substr($this->wp_version, 0, 3) >= '2.5') { ?>
                <div id="postaiosp" class="postbox closed">
                <h3><?php _e('All in One SEO Pack', 'all_in_one_seo_pack') ?></h3>
                <div class="inside">
                <div id="postaiosp">
                <?php } else { ?>
                <div class="dbx-b-ox-wrapper">
                <fieldset id="seodiv" class="dbx-box">
                <div class="dbx-h-andle-wrapper">
                <h3 class="dbx-handle"><?php _e('All in One SEO Pack', 'all_in_one_seo_pack') ?></h3>
                </div>
                <div class="dbx-c-ontent-wrapper">
                <div class="dbx-content">
                <?php } ?>
	
		<a target="__blank" href="http://semperfiwebdesign.com/portfolio/wordpress/wordpress-plugins/all-in-one-seo-pack/"><?php _e('Click here for Support', 'all_in_one_seo_pack') ?></a>
		<input value="aiosp_edit" type="hidden" name="aiosp_edit" />
		<table style="margin-bottom:40px">
		<tr>
		<th style="text-align:left;" colspan="2">
		</th>
		</tr>
		<tr>
		<th scope="row" style="text-align:right;"><?php _e('Title:', 'all_in_one_seo_pack') ?></th>
		<td><input value="<?php echo $title ?>" type="text" name="aiosp_title" size="62"/></td>
		</tr>
		<tr>
		<th scope="row" style="text-align:right;"><?php _e('Description:', 'all_in_one_seo_pack') ?></th>
		<td><textarea name="aiosp_description" rows="1" cols="60"
		onKeyDown="countChars(document.post.aiosp_description,document.post.length1)"
		onKeyUp="countChars(document.post.aiosp_description,document.post.length1)"><?php echo $description ?></textarea><br />
		<input readonly type="text" name="length1" size="3" maxlength="3" value="<?php echo strlen($description);?>" />
		<?php _e(' characters. Most search engines use a maximum of 160 chars for the description.', 'all_in_one_seo_pack') ?>
		</td>
		</tr>
		<tr>
		<th scope="row" style="text-align:right;"><?php _e('Keywords (comma separated):', 'all_in_one_seo_pack') ?></th>
		<td><input value="<?php echo $keywords ?>" type="text" name="aiosp_keywords" size="62"/></td>
		</tr>

		<?php if ($this->is_admin()) { ?>
		<tr>
		<th scope="row" style="text-align:right; vertical-align:top;">
		<?php _e('Disable on this page/post:', 'all_in_one_seo_pack')?>
		</th>
		<td>
		<input type="checkbox" name="aiosp_disable" <?php if ($aiosp_disable) echo "checked=\"1\""; ?>/>
		</td>
		</tr>
		<?php } ?>

		</table>
		
		<?php if (substr($this->wp_version, 0, 3) >= '2.5') { ?>
		</div></div></div>
		<?php } else { ?>
		</div>
		</fieldset>
		</div>
		<?php } ?>

		<?php
	}

	function admin_menu() {
		$file = __FILE__;
		
		// hack for 1.5
		if (substr($this->wp_version, 0, 3) == '1.5') {
			$file = 'all-in-one-seo-pack/all_in_one_seo_pack.php';
		}
		//add_management_page(__('All in One SEO Title', 'all_in_one_seo_pack'), __('All in One SEO', 'all_in_one_seo_pack'), 10, $file, array($this, 'management_panel'));
		add_submenu_page('options-general.php', __('All in One SEO', 'all_in_one_seo_pack'), __('All in One SEO', 'all_in_one_seo_pack'), 10, $file, array($this, 'options_panel'));
	}
	
	function management_panel() {
		$message = null;
		$base_url = "edit.php?page=" . __FILE__;
		//echo($base_url);
		$type = $_REQUEST['type'];
		if (!isset($type)) {
			$type = "posts";
		}
?>

  <ul class="aiosp_menu">
    <li><a href="<?php echo $base_url ?>&type=posts">Posts</a>
    </li>
    <li><a href="<?php echo $base_url ?>&type=pages">Pages</a>
    </li>
  </ul>
  
<?php

		if ($type == "posts") {
			echo("posts");
		} elseif ($type == "pages") {
			echo("pages");
		}

	}

	function options_panel() {
		$message = null;
		$message_updated = __("All in One SEO Options Updated.", 'all_in_one_seo_pack');
		
		// update options
		if ($_POST['action'] && $_POST['action'] == 'aiosp_update') {
			$message = $message_updated;
			update_option('aiosp_home_title', $_POST['aiosp_home_title']);
			update_option('aiosp_home_description', $_POST['aiosp_home_description']);
			update_option('aiosp_home_keywords', $_POST['aiosp_home_keywords']);
			update_option('aiosp_max_words_excerpt', $_POST['aiosp_max_words_excerpt']);
			update_option('aiosp_rewrite_titles', $_POST['aiosp_rewrite_titles']);
			update_option('aiosp_post_title_format', $_POST['aiosp_post_title_format']);
			update_option('aiosp_page_title_format', $_POST['aiosp_page_title_format']);
			update_option('aiosp_category_title_format', $_POST['aiosp_category_title_format']);
			update_option('aiosp_archive_title_format', $_POST['aiosp_archive_title_format']);
			update_option('aiosp_tag_title_format', $_POST['aiosp_tag_title_format']);
			update_option('aiosp_search_title_format', $_POST['aiosp_search_title_format']);
			update_option('aiosp_description_format', $_POST['aiosp_description_format']);
			update_option('aiosp_404_title_format', $_POST['aiosp_404_title_format']);
			update_option('aiosp_paged_format', $_POST['aiosp_paged_format']);
			update_option('aiosp_use_categories', $_POST['aiosp_use_categories']);
			update_option('aiosp_category_noindex', $_POST['aiosp_category_noindex']);
			update_option('aiosp_archive_noindex', $_POST['aiosp_archive_noindex']);
			update_option('aiosp_tags_noindex', $_POST['aiosp_tags_noindex']);
			update_option('aiosp_generate_descriptions', $_POST['aiosp_generate_descriptions']);
			update_option('aiosp_debug_info', $_POST['aiosp_debug_info']);
			update_option('aiosp_post_meta_tags', $_POST['aiosp_post_meta_tags']);
			update_option('aiosp_page_meta_tags', $_POST['aiosp_page_meta_tags']);
			update_option('aiosp_home_meta_tags', $_POST['aiosp_home_meta_tags']);
			update_option('aiosp_do_log', $_POST['aiosp_do_log']);
			if (function_exists('wp_cache_flush')) {
				wp_cache_flush();
			}
		} elseif ($_POST['aiosp_upgrade']) {
			$message = __("Upgraded to newest version. Please revisit the options page to make sure you see the newest version.", 'all_in_one_seo_pack');
			$success = $this->install_newest_version();
			if (!$success) {
				$message = __("Upgrade failed", 'all_in_one_seo_pack');
				if (isset($this->upgrade_error) && !empty($this->upgrade_error)) {
					$message .= ": " . $this->upgrade_error;
				} else {
					$message .= ".";
				}
			}
		}

?>
<?php if ($message) : ?>
<div id="message" class="updated fade"><p><?php echo $message; ?></p></div>
<?php endif; ?>
<div id="dropmessage" class="updated" style="display:none;"></div>
<div class="wrap">
<h2><?php _e('All in One SEO настройки', 'all_in_one_seo_pack'); ?></h2>
<p>
<?php _e("Это версия ", 'all_in_one_seo_pack') ?><?php _e("$this->version ", 'all_in_one_seo_pack') ?>
&nbsp;<a target="_blank" title="<?php _e('All in One SEO Plugin Release History', 'all_in_one_seo_pack')?>"
href="http://semperfiwebdesign.com/documentation/all-in-one-seo-pack/all-in-one-seo-pack-release-history/"><?php _e("Узнать о новых версиях?", 'all_in_one_seo_pack')?>
</a>
| Плагин переведен на сайте <a href="http://wpworld.ru" terget="_blank" title="Мир Wordpress">Мир wordpress</a>
| При поддержке сайта <a href="http://wpthemes.ru" title="Темы для wordpress" target="_blank">Темы для wordpress</a>
<p>
<?php
$canwrite = $this->is_upgrade_directory_writable();
//$canwrite = false;
?>
<form class="form-table" name="dofollow" action="" method="post">
<p class="submit">
<input type="submit" <?php if (!$canwrite) echo(' disabled="disabled" ');?> name="aiosp_upgrade" value="<?php _e('Одно нажатие для обновления', 'all_in_one_seo_pack')?> &raquo;" />
<strong><?php _e("(Помните: процесс необратим, вовремя делайте backup!)", 'all_in_one_seo_pack') ?></strong>
</form>
</p>
<p></p>

<?php if (!$canwrite) {
	echo("<p><strong>"); echo(sprintf(__("Please make sure that %s is writable.", 'all_in_one_seo_pack'), $this->upgrade_folder)); echo("</p></strong>");
} ?>
</p>

<script type="text/javascript">
<!--
    function toggleVisibility(id) {
       var e = document.getElementById(id);
       if(e.style.display == 'block')
          e.style.display = 'none';
       else
          e.style.display = 'block';
    }
//-->
</script>

<h3><?php _e('Нажмите на название, чтобы вызвать подсказку!', 'all_in_one_seo_pack') ?></h3>

<form name="dofollow" action="" method="post">
<table class="form-table">

<tr>
<th scope="row" style="text-align:right; vertical-align:top;">
<a style="cursor:pointer;" title="<?php _e('Click for Help!', 'all_in_one_seo_pack')?>" onclick="toggleVisibility('aiosp_home_title_tip');">
<?php _e('Title для главной страницы:', 'all_in_one_seo_pack')?>
</a>
</td>
<td>
<textarea cols="57" rows="2" name="aiosp_home_title"><?php echo stripcslashes(get_option('aiosp_home_title')); ?></textarea>
<div style="max-width:500px; text-align:left; display:none" id="aiosp_home_title_tip">
<?php
_e('Это тот заголовок, который будет писаться для главной страницы. Если ничего не будет вписано, то загаловок будет стандартным.', 'all_in_one_seo_pack');
 ?>
</div>
</td>
</tr>

<tr>
<th scope="row" style="text-align:right; vertical-align:top;">
<a style="cursor:pointer;" title="<?php _e('Click for Help!', 'all_in_one_seo_pack')?>" onclick="toggleVisibility('aiosp_home_description_tip');">
<?php _e('Описание главной страницы:', 'all_in_one_seo_pack')?>
</a>
</td>
<td>
<textarea cols="57" rows="2" name="aiosp_home_description"><?php echo stripcslashes(get_option('aiosp_home_description')); ?></textarea>
<div style="max-width:500px; text-align:left; display:none" id="aiosp_home_description_tip">
<?php
_e('Это описание для вашей главной страницы, которое будут читать поисковые роботы.', 'all_in_one_seo_pack');
 ?>
</div>
</td>
</tr>

<tr>
<th scope="row" style="text-align:right; vertical-align:top;">
<a style="cursor:pointer;" title="<?php _e('Click for Help!', 'all_in_one_seo_pack')?>" onclick="toggleVisibility('aiosp_home_keywords_tip');">
<?php _e('Ключевые слова главной страницы:', 'all_in_one_seo_pack')?>
</a>
</td>
<td>
<textarea cols="57" rows="2" name="aiosp_home_keywords"><?php echo stripcslashes(get_option('aiosp_home_keywords')); ?></textarea>
<div style="max-width:500px; text-align:left; display:none" id="aiosp_home_keywords_tip">
<?php
_e("Указываете несколько слов, которые наиболее ярко описывают деятельность вашего сайта.", 'all_in_one_seo_pack');
 ?>
</div>
</td>
</tr>

<tr>
<th scope="row" style="text-align:right; vertical-align:top;">
<a style="cursor:pointer;" title="<?php _e('Click for Help!', 'all_in_one_seo_pack')?>" onclick="toggleVisibility('aiosp_rewrite_titles_tip');">
<?php _e('Перезапись заголовков:', 'all_in_one_seo_pack')?>
</a>
</td>
<td>
<input type="checkbox" name="aiosp_rewrite_titles" <?php if (get_option('aiosp_rewrite_titles')) echo "checked=\"1\""; ?>/>
<div style="max-width:500px; text-align:left; display:none" id="aiosp_rewrite_titles_tip">
<?php
_e("Здесь выбирается - перезаписывать заголовки или оставлять стандартными. Я бы посоветовал перезаписывать.", 'all_in_one_seo_pack');
 ?>
</div>
</td>
</tr>

<tr>
<th scope="row" style="text-align:right; vertical-align:top;">
<a style="cursor:pointer;" title="<?php _e('Click for Help!', 'all_in_one_seo_pack')?>" onclick="toggleVisibility('aiosp_post_title_format_tip');">
<?php _e('Формат для заголовков:', 'all_in_one_seo_pack')?>
</a>
</td>
<td>
<input size="59" name="aiosp_post_title_format" value="<?php echo stripcslashes(get_option('aiosp_post_title_format')); ?>"/>
<div style="max-width:500px; text-align:left; display:none" id="aiosp_post_title_format_tip">
<?php
_e('Примеры для записи:', 'all_in_one_seo_pack');
echo('<ul>');
echo('<li>'); _e('%blog_title% - Название вашего блога', 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e('%blog_description% - Описание вашего блога', 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e('%post_title% - Оригинальный заголовок записи', 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e('%category_title% - Главная категория записи', 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e('%category% - Псевдоним для %category_title%', 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e("%post_author_login% - Автор этой записи login", 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e("%post_author_nicename% - Альтернативное имя автора", 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e("%post_author_firstname% - Имя автора этой статьи", 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e("%post_author_lastname% - Фамилия автора статьи", 'all_in_one_seo_pack'); echo('</li>');
echo('</ul>');
 ?>
</div>
</td>
</tr>

<tr>
<th scope="row" style="text-align:right; vertical-align:top;">
<a style="cursor:pointer;" title="<?php _e('Click for Help!', 'all_in_one_seo_pack')?>" onclick="toggleVisibility('aiosp_page_title_format_tip');">
<?php _e('Формат заголовка страницы:', 'all_in_one_seo_pack')?>
</a>
</td>
<td>
<input size="59" name="aiosp_page_title_format" value="<?php echo stripcslashes(get_option('aiosp_page_title_format')); ?>"/>
<div style="max-width:500px; text-align:left; display:none" id="aiosp_page_title_format_tip">
<?php
_e('Примеры для страницы:', 'all_in_one_seo_pack');
echo('<ul>');
echo('<li>'); _e('%blog_title% - Название вашего блога', 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e('%blog_description% - Описание вашего блога', 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e('%page_title% - Оригинальное название страницы', 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e("%page_author_login% - Автор страницы", 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e("%page_author_nicename% - Альтернативное имя автора страницы", 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e("%page_author_firstname% - Имя автора страницы", 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e("%page_author_lastname% - Фамилия автора страницы", 'all_in_one_seo_pack'); echo('</li>');
echo('</ul>');
 ?>
</div>
</td>
</tr>

<tr>
<th scope="row" style="text-align:right; vertical-align:top;">
<a style="cursor:pointer;" title="<?php _e('Click for Help!', 'all_in_one_seo_pack')?>" onclick="toggleVisibility('aiosp_category_title_format_tip');">
<?php _e('Формат категорий:', 'all_in_one_seo_pack')?>
</a>
</td>
<td>
<input size="59" name="aiosp_category_title_format" value="<?php echo stripcslashes(get_option('aiosp_category_title_format')); ?>"/>
<div style="max-width:500px; text-align:left; display:none" id="aiosp_category_title_format_tip">
<?php
_e('Примеры для категорий:', 'all_in_one_seo_pack');
echo('<ul>');
echo('<li>'); _e('%blog_title% - Название вашего блога', 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e('%blog_description% - Описание вашего блога', 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e('%category_title% - Оригинальный заголовок для категории', 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e('%category_description% - Описание для категории', 'all_in_one_seo_pack'); echo('</li>');
echo('</ul>');
 ?>
</div>
</td>
</tr>

<tr>
<th scope="row" style="text-align:right; vertical-align:top;">
<a style="cursor:pointer;" title="<?php _e('Click for Help!', 'all_in_one_seo_pack')?>" onclick="toggleVisibility('aiosp_archive_title_format_tip');">
<?php _e('Формат архива:', 'all_in_one_seo_pack')?>
</a>
</td>
<td>
<input size="59" name="aiosp_archive_title_format" value="<?php echo stripcslashes(get_option('aiosp_archive_title_format')); ?>"/>
<div style="max-width:500px; text-align:left; display:none" id="aiosp_archive_title_format_tip">
<?php
_e('Примеры для архива:', 'all_in_one_seo_pack');
echo('<ul>');
echo('<li>'); _e('%blog_title% - Название вашего блога', 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e('%blog_description% - Описание вашего блога', 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e('%date% - Оригинальный заголовок для архива', 'all_in_one_seo_pack'); echo('</li>');
echo('</ul>');
 ?>
</div>
</td>
</tr>

<tr>
<th scope="row" style="text-align:right; vertical-align:top;">
<a style="cursor:pointer;" title="<?php _e('Click for Help!', 'all_in_one_seo_pack')?>" onclick="toggleVisibility('aiosp_tag_title_format_tip');">
<?php _e('Формт для тегов:', 'all_in_one_seo_pack')?>
</a>
</td>
<td>
<input size="59" name="aiosp_tag_title_format" value="<?php echo stripcslashes(get_option('aiosp_tag_title_format')); ?>"/>
<div style="max-width:500px; text-align:left; display:none" id="aiosp_tag_title_format_tip">
<?php
_e('Примеры для тегов:', 'all_in_one_seo_pack');
echo('<ul>');
echo('<li>'); _e('%blog_title% - Название вашего блога', 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e('%blog_description% - Описание вашего блога', 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e('%tag% - Название тега', 'all_in_one_seo_pack'); echo('</li>');
echo('</ul>');
 ?>
</div>
</td>
</tr>

<tr>
<th scope="row" style="text-align:right; vertical-align:top;">
<a style="cursor:pointer;" title="<?php _e('Click for Help!', 'all_in_one_seo_pack')?>" onclick="toggleVisibility('aiosp_search_title_format_tip');">
<?php _e('Формат для поиска:', 'all_in_one_seo_pack')?>
</a>
</td>
<td>
<input size="59" name="aiosp_search_title_format" value="<?php echo stripcslashes(get_option('aiosp_search_title_format')); ?>"/>
<div style="max-width:500px; text-align:left; display:none" id="aiosp_search_title_format_tip">
<?php
_e('Примеры для поиска:', 'all_in_one_seo_pack');
echo('<ul>');
echo('<li>'); _e('%blog_title% - Название вашего блога', 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e('%blog_description% - Описание вашего блога', 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e('%search% - Что вы искали...', 'all_in_one_seo_pack'); echo('</li>');
echo('</ul>');
 ?>
</div>
</td>
</tr>

<tr>
<th scope="row" style="text-align:right; vertical-align:top;">
<a style="cursor:pointer;" title="<?php _e('Click for Help!', 'all_in_one_seo_pack')?>" onclick="toggleVisibility('aiosp_description_format_tip');">
<?php _e('Формат для описаний:', 'all_in_one_seo_pack')?>
</a>
</td>
<td>
<input size="59" name="aiosp_description_format" value="<?php echo stripcslashes(get_option('aiosp_description_format')); ?>"/>
<div style="max-width:500px; text-align:left; display:none" id="aiosp_description_format_tip">
<?php
_e('Примеры для описания:', 'all_in_one_seo_pack');
echo('<ul>');
echo('<li>'); _e('%blog_title% - Название блога', 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e('%blog_description% - Описание блога', 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e('%description% - Оригинальное описание', 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e('%wp_title% - Оригинальный заголовок', 'all_in_one_seo_pack'); echo('</li>');
echo('</ul>');
 ?>
</div>
</td>
</tr>

<tr>
<th scope="row" style="text-align:right; vertical-align:top;">
<a style="cursor:pointer;" title="<?php _e('Click for Help!', 'all_in_one_seo_pack')?>" onclick="toggleVisibility('aiosp_404_title_format_tip');">
<?php _e('Формат страницы 404:', 'all_in_one_seo_pack')?>
</a>
</td>
<td>
<input size="59" name="aiosp_404_title_format" value="<?php echo stripcslashes(get_option('aiosp_404_title_format')); ?>"/>
<div style="max-width:500px; text-align:left; display:none" id="aiosp_404_title_format_tip">
<?php
_e('Примеры для страницы 404:', 'all_in_one_seo_pack');
echo('<ul>');
echo('<li>'); _e('%blog_title% - Название вашего блога', 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e('%blog_description% - Описание вашего блога', 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e('%request_url% - Оригинальный URL"', 'all_in_one_seo_pack'); echo('</li>');
echo('<li>'); _e('%request_words% - Человекупонятный URL', 'all_in_one_seo_pack'); echo('</li>');
echo('</ul>');
 ?>
</div>
</td>
</tr>

<tr>
<th scope="row" style="text-align:right; vertical-align:top;">
<a style="cursor:pointer;" title="<?php _e('Click for Help!', 'all_in_one_seo_pack')?>" onclick="toggleVisibility('aiosp_paged_format_tip');">
<?php _e('Формат страницы:', 'all_in_one_seo_pack')?>
</a>
</td>
<td>
<input size="59" name="aiosp_paged_format" value="<?php echo stripcslashes(get_option('aiosp_paged_format')); ?>"/>
<div style="max-width:500px; text-align:left; display:none" id="aiosp_paged_format_tip">
<?php
_e('', 'all_in_one_seo_pack');
_e('Примеры для страницы:', 'all_in_one_seo_pack');
echo('<ul>');
echo('<li>'); _e('%page% - Номер страницы', 'all_in_one_seo_pack'); echo('</li>');
echo('</ul>');
 ?>
</div>
</td>
</tr>

<tr>
<th scope="row" style="text-align:right; vertical-align:top;">
<a style="cursor:pointer;" title="<?php _e('Click for Help!', 'all_in_one_seo_pack')?>" onclick="toggleVisibility('aiosp_use_categories_tip');">
<?php _e('Использование в категориях ключевых слов:', 'all_in_one_seo_pack')?>
</td>
<td>
<input type="checkbox" name="aiosp_use_categories" <?php if (get_option('aiosp_use_categories')) echo "checked=\"1\""; ?>/>
<div style="max-width:500px; text-align:left; display:none" id="aiosp_use_categories_tip">
<?php
_e('Используйте для того чтобы в записях были ключевые слова категории.', 'all_in_one_seo_pack');
 ?>
</div>
</td>
</tr>

<tr>
<th scope="row" style="text-align:right; vertical-align:top;">
<a style="cursor:pointer;" title="<?php _e('Click for Help!', 'all_in_one_seo_pack')?>" onclick="toggleVisibility('aiosp_category_noindex_tip');">
<?php _e('Запретить индексацию категорий:', 'all_in_one_seo_pack')?>
</a>
</td>
<td>
<input type="checkbox" name="aiosp_category_noindex" <?php if (get_option('aiosp_category_noindex')) echo "checked=\"1\""; ?>/>
<div style="max-width:500px; text-align:left; display:none" id="aiosp_category_noindex_tip">
<?php
_e('Запрещает роботам индексировать категории, помогает избежать дубликации контента.', 'all_in_one_seo_pack');
 ?>
</div>
</td>
</tr>

<tr>
<th scope="row" style="text-align:right; vertical-align:top;">
<a style="cursor:pointer;" title="<?php _e('Click for Help!', 'all_in_one_seo_pack')?>" onclick="toggleVisibility('aiosp_archive_noindex_tip');">
<?php _e('Запретить индексацию архивов:', 'all_in_one_seo_pack')?>
</a>
</td>
<td>
<input type="checkbox" name="aiosp_archive_noindex" <?php if (get_option('aiosp_archive_noindex')) echo "checked=\"1\""; ?>/>
<div style="max-width:500px; text-align:left; display:none" id="aiosp_archive_noindex_tip">
<?php
_e('Запрещает роботам индексировать архивы, помогает избежать дубликации контента.', 'all_in_one_seo_pack');
 ?>
</div>
</td>
</tr>

<tr>
<th scope="row" style="text-align:right; vertical-align:top;">
<a style="cursor:pointer;" title="<?php _e('Click for Help!', 'all_in_one_seo_pack')?>" onclick="toggleVisibility('aiosp_tags_noindex_tip');">
<?php _e('Запретить индексацию тегов:', 'all_in_one_seo_pack')?>
</a>
</td>
<td>
<input type="checkbox" name="aiosp_tags_noindex" <?php if (get_option('aiosp_tags_noindex')) echo "checked=\"1\""; ?>/>
<div style="max-width:500px; text-align:left; display:none" id="aiosp_tags_noindex_tip">
<?php
_e('Запрещает роботам индексировать архивы тегов, помогает избежать дубликации контента.', 'all_in_one_seo_pack');
 ?>
</div>
</td>
</tr>

<tr>
<th scope="row" style="text-align:right; vertical-align:top;">
<a style="cursor:pointer;" title="<?php _e('Click for Help!', 'all_in_one_seo_pack')?>" onclick="toggleVisibility('aiosp_generate_descriptions_tip');">
<?php _e('Автогенерирование описания:', 'all_in_one_seo_pack')?>
</a>
</td>
<td>
<input type="checkbox" name="aiosp_generate_descriptions" <?php if (get_option('aiosp_generate_descriptions')) echo "checked=\"1\""; ?>/>
<div style="max-width:500px; text-align:left; display:none" id="aiosp_generate_descriptions_tip">
<?php
_e("Активируйте для того чтобы описание генерировалось автоматически.", 'all_in_one_seo_pack');
 ?>
</div>
</td>
</tr>

<tr>
<th scope="row" style="text-align:right; vertical-align:top;">
<a style="cursor:pointer;" title="<?php _e('Click for Help!', 'all_in_one_seo_pack')?>" onclick="toggleVisibility('aiosp_post_meta_tags_tip');">
<?php _e('Дополнительные текст для записей:', 'all_in_one_seo_pack')?>
</a>
</td>
<td>
<textarea cols="57" rows="2" name="aiosp_post_meta_tags"><?php echo stripcslashes(get_option('aiosp_post_meta_tags')); ?></textarea>
<div style="max-width:500px; text-align:left; display:none" id="aiosp_post_meta_tags_tip">
<?php
_e('То что вы здесь напишете будет в самом верху записей.', 'all_in_one_seo_pack');
 ?>
</div>
</td>
</tr>

<tr>
<th scope="row" style="text-align:right; vertical-align:top;">
<a style="cursor:pointer;" title="<?php _e('Click for Help!', 'all_in_one_seo_pack')?>" onclick="toggleVisibility('aiosp_page_meta_tags_tip');">
<?php _e('Дополнительные текс для страниц:', 'all_in_one_seo_pack')?>
</a>
</td>
<td>
<textarea cols="57" rows="2" name="aiosp_page_meta_tags"><?php echo stripcslashes(get_option('aiosp_page_meta_tags')); ?></textarea>
<div style="max-width:500px; text-align:left; display:none" id="aiosp_page_meta_tags_tip">
<?php
_e('То что вы здесь напишете будет написано в самом верху страниц страниц.', 'all_in_one_seo_pack');
 ?>
</div>
</td>
</tr>

<tr>
<th scope="row" style="text-align:right; vertical-align:top;">
<a style="cursor:pointer;" title="<?php _e('Click for Help!', 'all_in_one_seo_pack')?>" onclick="toggleVisibility('aiosp_home_meta_tags_tip');">
<?php _e('Дополнительный текст для header:', 'all_in_one_seo_pack')?>
</a>
</td>
<td>
<textarea cols="57" rows="2" name="aiosp_home_meta_tags"><?php echo stripcslashes(get_option('aiosp_home_meta_tags')); ?></textarea>
<div style="max-width:500px; text-align:left; display:none" id="aiosp_home_meta_tags_tip">
<?php
_e('То что вы здесь впишите будет в самом верху страницы.', 'all_in_one_seo_pack');
 ?>
</div>
</td>
</tr>

<tr>
<th scope="row" style="text-align:right; vertical-align:top;">
<a style="cursor:pointer;" title="<?php _e('Click for Help!', 'auto_social')?>" onclick="toggleVisibility('aiosp_do_log_tip');">
<?php _e('Сохранять настройки:', 'all_in_one_seo_pack')?>
</a>
</td>
<td>
<input type="checkbox" name="aiosp_do_log" <?php if (get_option('aiosp_do_log')) echo "checked=\"1\""; ?>/>
<div style="max-width:500px; text-align:left; display:none" id="aiosp_do_log_tip">
<?php
_e('После применения wordpress будет записывать настройки в файл all_in_one_seo_pack.log, что облегчит настройку на др. сервере', 'all_in_one_seo_pack');
 ?>
</div>
</td>
</tr>

</table>
<p class="submit">
<input type="hidden" name="action" value="aiosp_update" /> 
<input type="hidden" name="page_options" value="aiosp_home_description" /> 
<input type="submit" name="Submit" value="<?php _e('Применить изменения', 'all_in_one_seo_pack')?> &raquo;" /> 
</p>
<p><br />
<strong>Посетите наши ресурсы</strong><br />
Скачано с <a href="http://wpworld.ru" terget="_blank" title="Мир Wordpress">Мир wordpress</a>, переведено на сайте <a href="http://wpthemes.ru" title="Темы для wordpress" target="_blank">Темы для wordpress</a>.
</p>
</form>
</div>
<?php
	
	} // options_panel

}

add_option("aiosp_home_description", null, 'All in One SEO Plugin Home Description', 'yes');
add_option("aiosp_home_title", null, 'All in One SEO Plugin Home Title', 'yes');
add_option("aiosp_rewrite_titles", 1, 'All in One SEO Plugin Rewrite Titles', 'yes');
add_option("aiosp_use_categories", 0, 'All in One SEO Plugin Use Categories', 'yes');
add_option("aiosp_category_noindex", 1, 'All in One SEO Plugin Noindex for Categories', 'yes');
add_option("aiosp_archive_noindex", 1, 'All in One SEO Plugin Noindex for Archives', 'yes');
add_option("aiosp_tags_noindex", 0, 'All in One SEO Plugin Noindex for Tag Archives', 'yes');
add_option("aiosp_generate_descriptions", 1, 'All in One SEO Plugin Autogenerate Descriptions', 'yes');
add_option("aiosp_post_title_format", '%post_title% | %blog_title%', 'All in One SEO Plugin Post Title Format', 'yes');
add_option("aiosp_page_title_format", '%page_title% | %blog_title%', 'All in One SEO Plugin Page Title Format', 'yes');
add_option("aiosp_category_title_format", '%category_title% | %blog_title%', 'All in One SEO Plugin Category Title Format', 'yes');
add_option("aiosp_archive_title_format", '%date% | %blog_title%', 'All in One SEO Plugin Archive Title Format', 'yes');
add_option("aiosp_tag_title_format", '%tag% | %blog_title%', 'All in One SEO Plugin Tag Title Format', 'yes');
add_option("aiosp_search_title_format", '%search% | %blog_title%', 'All in One SEO Plugin Search Title Format', 'yes');
add_option("aiosp_description_format", '%description%', 'All in One SEO Plugin Description Format', 'yes');
add_option("aiosp_paged_format", ' - Part %page%', 'All in One SEO Plugin Paged Format', 'yes');
add_option("aiosp_404_title_format", 'Nothing found for %request_words%', 'All in One SEO Plugin 404 Title Format', 'yes');
add_option("aiosp_post_meta_tags", '', 'All in One SEO Plugin Additional Post Meta Tags', 'yes');
add_option("aiosp_page_meta_tags", '', 'All in One SEO Plugin Additional Post Meta Tags', 'yes');
add_option("aiosp_home_meta_tags", '', 'All in One SEO Plugin Additional Home Meta Tags', 'yes');
add_option("aiosp_do_log", null, 'All in One SEO Plugin write log file', 'yes');

$aiosp = new All_in_One_SEO_Pack();
add_action('wp_head', array($aiosp, 'wp_head'));
add_action('template_redirect', array($aiosp, 'template_redirect'));

add_action('init', array($aiosp, 'init'));

if (substr($aiosp->wp_version, 0, 3) >= '2.5') {
	add_action('edit_form_advanced', array($aiosp, 'add_meta_tags_textinput'));
	add_action('edit_page_form', array($aiosp, 'add_meta_tags_textinput'));
} else {
	add_action('dbx_post_advanced', array($aiosp, 'add_meta_tags_textinput'));
	add_action('dbx_page_advanced', array($aiosp, 'add_meta_tags_textinput'));
}

add_action('edit_post', array($aiosp, 'post_meta_tags'));
add_action('publish_post', array($aiosp, 'post_meta_tags'));
add_action('save_post', array($aiosp, 'post_meta_tags'));
add_action('edit_page_form', array($aiosp, 'post_meta_tags'));

add_action('admin_menu', array($aiosp, 'admin_menu'));
?>
